// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "StdAfx.h"
#include ".\commandarray.h"

CCommandArray::CCommandArray(void)
{
	RemoveAll();
}

CCommandArray::~CCommandArray(void)
{
	RemoveAll();
}

CCommandType CCommandArray::Get(LPCTSTR name)
{
	INT_PTR count = GetCount();
	for (INT_PTR i = 0; i < count; i++) {
		CCommandType element = GetAt(i);
		if (!_tcsicmp(element.GetAppName(), name)) {	// v
			return element;
		}
	}
	return CCommandType(_T(""), _T(""));
}

VOID CCommandArray::Update(VOID)
{
	INT_PTR count = GetCount();
	for (INT_PTR i = 0; i < count; i++) {
		GetAt(i).WriteProfile();
	}
}

INT_PTR CCommandArray::Find(LPCTSTR str) const
{
	INT_PTR count = GetCount();
	for (INT_PTR i = 0; i < count; i++) {
		CString element = GetAt(i).GetAppName();
		if (!element.CompareNoCase(str)) {
			return i;
		}
	}
	return -1;
}
