// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "StdAfx.h"
#include ".\commandtype.h"

CCommandType::CCommandType(void)
{
	m_AppName.Empty();
	m_ExeName.Empty();
	m_Opt.Empty();
}

CCommandType::~CCommandType(void)
{
	m_AppName.Empty();
	m_ExeName.Empty();
	m_Opt.Empty();
}

VOID CCommandType::Initialize(LPCTSTR appName, LPCTSTR exeName, LPCTSTR opt)
{
	m_AppName = appName;
	CWinApp *pApp = AfxGetApp();
	m_ExeName = ConvertFromProfile(pApp->GetProfileString(m_AppName, _T("EXE"), ConvertToProfile(exeName)));
	m_Opt = ConvertFromProfile(pApp->GetProfileString(m_AppName, _T("OPTION"), ConvertToProfile(opt)));
}

VOID CCommandType::WriteProfile(VOID) const
{
	CWinApp *pApp = AfxGetApp();
	pApp->WriteProfileString(m_AppName, _T("EXE"), ConvertToProfile(m_ExeName));
	pApp->WriteProfileString(m_AppName, _T("OPTION"), ConvertToProfile(m_Opt));
}

VOID CCommandType::Copy(const CCommandType &obj)
{
	m_AppName = obj.m_AppName;
	m_ExeName = obj.m_ExeName;
	m_Opt = obj.m_Opt;
}

CString CCommandType::ConvertFromProfile(const CString &str)
{
	CString work;
	work.Empty();
	int len = str.GetLength();
	for (int i = 0; i < len; i++) {
		TCHAR ch = str[i];
		if (ch == _T('\\')) {
			switch (str[i + 1]) {
				case _T('\"'):
					work += _T('\"');
					i++;
					break;
				case _T('\''):
					work += _T('\'');
					i++;
					break;
				default:
					work += ch;
			}
		} else {
			work += ch;
		}
	}
	return work;
}

CString CCommandType::ConvertToProfile(LPCTSTR str)
{
	CString work;
	work.Empty();
	int len = (int)_tcslen(str);
	for (int i = 0; i < len; i++) {
		TCHAR ch = str[i];
		switch (ch) {
			case _T('\"'):
				work += _T("\\\"");
				break;
			case _T('\''):
				work += _T("\\\'");
				break;
			default:
				work += ch;
		}
	}
	return work;
}
