// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

class CCommandType
{
private:
	CString m_AppName;		// AvP[V̖O
	CString m_ExeName;		// st@C
	CString m_Opt;			// R}hCIvV

	static CString ConvertFromProfile(const CString &str);
	static CString ConvertToProfile(LPCTSTR str);

public:
	CCommandType(void);
	CCommandType(const CCommandType &obj)
	{
		Copy(obj);
	}
	CCommandType(LPCTSTR appName, LPCTSTR exeName, LPCTSTR opt = _T(""))
	{
		Initialize(appName, exeName, opt);
	}
	virtual ~CCommandType(void);
	VOID Initialize(LPCTSTR appName, LPCTSTR exeName, LPCTSTR opt = _T(""));
	VOID WriteProfile(VOID) const;
	VOID Copy(const CCommandType &obj);
	const CCommandType &operator=(const CCommandType &obj)
	{
		Copy(obj);
		return *this;
	}
	LPCTSTR GetAppName(VOID) const
	{
		return (LPCTSTR)m_AppName;
	}
	LPCTSTR GetExeName(VOID) const
	{
		return (LPCTSTR)m_ExeName;
	}
	LPCTSTR GetOption(VOID) const
	{
		return (LPCTSTR)m_Opt;
	}
	CString GetOption(LPCTSTR fileName) const
	{
		CString work;
		work.Format(m_Opt, fileName);
		return work;
	}
	VOID SetExeName(LPCSTR exeName)
	{
		m_ExeName = exeName;
	}
	VOID SetExeName(const CString &exeName)
	{
		m_ExeName = exeName;
	}
	VOID SetOption(LPCTSTR opt)
	{
		m_Opt = opt;
	}
	VOID SetOption(const CString &opt)
	{
		m_Opt = opt;
	}
	CString GetCommandLine(LPCTSTR fileName) const
	{
		// w肵t@C(gqȂ)ɁAR}hC쐬
		CString work;
		work.Format(_T("%s %s"), static_cast<LPCTSTR>(m_ExeName), static_cast<LPCTSTR>(GetOption(fileName)));
		return work;
	}
};
