// ConsoleView.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "ConsoleView.h"
#include ".\consoleview.h"
//#include "MainFrm.h"
#include <new>

using namespace std;

// CConsoleView

IMPLEMENT_DYNCREATE(CConsoleView, CEditView)

CConsoleView::CConsoleView() : m_LastChar(NULL)
{
}

CConsoleView::~CConsoleView()
{
}

BEGIN_MESSAGE_MAP(CConsoleView, CEditView)
	ON_WM_RBUTTONDOWN()
	ON_CONTROL_REFLECT(EN_CHANGE, OnEnChange)
END_MESSAGE_MAP()


// CConsoleView ff

#ifdef _DEBUG
void CConsoleView::AssertValid() const
{
	CEditView::AssertValid();
}

void CConsoleView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}
#endif //_DEBUG


// CConsoleView bZ[W nh

void CConsoleView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	// IDR_MENU_POPUPpopup1̓e\
	CMenu menu;
	menu.LoadMenu(IDR_MENU_POPUP);
	CMenu *pMenu = menu.GetSubMenu(1);

	// eڂ̗L/ݒ肷
	CEdit &edit = GetEditCtrl();
	int selStartPos, selEndPos;
	edit.GetSel(selStartPos, selEndPos);
	if (selStartPos == selEndPos) {
		pMenu->EnableMenuItem(ID_EDIT_COPY, MF_BYCOMMAND | MF_GRAYED);
	} else {
		pMenu->EnableMenuItem(ID_EDIT_COPY, MF_BYCOMMAND | MF_ENABLED);
	}

	ClientToScreen(&point);
	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
	menu.DestroyMenu();

//	CEditView::OnRButtonDown(nFlags, point);
}

BOOL CConsoleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	cs.style |= (WS_HSCROLL | WS_VSCROLL | ES_READONLY | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL);

	return CEditView::PreCreateWindow(cs);
}

void CConsoleView::OnInitialUpdate()
{
	CEditView::OnInitialUpdate();

	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	theApp.SetConsoleView(this);
}

BOOL CConsoleView::Execute(LPCTSTR cmd, LPCTSTR currentDir)
{
	{	// ͖wǃfobOړIȂ̂ŁAʃubNɂĂ
		// sR}h\
		CEdit &edit = GetEditCtrl();
		edit.SetSel(-1, -1);
		CString disp;
		disp.Format(_T("%s>%s\r\n"), currentDir, cmd);
		edit.ReplaceSel(disp);
	}

	// R\[o͎擾ppCv̍쐬
	HANDLE hReadPipe = NULL, hWritePipe = NULL, hErrReadPipe = NULL, hErrWritePipe = NULL;
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(sa);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;
	const unsigned int pipe_size = CONSOLE_VIEW_BUFSIZE - 1;
	if (!::CreatePipe(&hReadPipe, &hWritePipe, &sa, pipe_size)) {
		CString base;
		base.LoadString(IDS_STRING_CANNOT_EXECUTE);
		CString msg;
		msg.Format(base, cmd);
		AfxMessageBox(msg, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	if (!::CreatePipe(&hErrReadPipe, &hErrWritePipe, &sa, pipe_size)) {
		CString base;
		base.LoadString(IDS_STRING_CANNOT_EXECUTE);
		CString msg;
		msg.Format(base, cmd);
		AfxMessageBox(msg, MB_OK | MB_ICONEXCLAMATION);
		::CloseHandle(hWritePipe);
		::CloseHandle(hReadPipe);
		return FALSE;
	}

	// CreateProcessW̑2ɂ͒萔^͎gȂ
	LPTSTR cmd2 = NULL;
	try {
		cmd2 = new TCHAR[CONSOLE_VIEW_BUFSIZE];
	} catch (bad_alloc xa) {
		CString base;
		base.LoadString(IDS_STRING_EXECUTE_MEMORY_ALLOCATION_ERROR);
		CString msg;
		msg.Format(base, cmd);
		AfxMessageBox(msg, MB_OK | MB_ICONEXCLAMATION);
		::CloseHandle(hWritePipe);
		::CloseHandle(hReadPipe);
		::CloseHandle(hErrWritePipe);
		::CloseHandle(hErrReadPipe);
		return FALSE;
	}
	memset(cmd2, NULL, sizeof(TCHAR) * CONSOLE_VIEW_BUFSIZE);
	_tcsncpy(cmd2, cmd, CONSOLE_VIEW_BUFSIZE - 1);

	STARTUPINFO si;
	memset(&si, NULL, sizeof(si));
	si.cb = sizeof(si);
	si.dwFlags = STARTF_USESTDHANDLES;
	si.wShowWindow = SW_HIDE;
	si.hStdOutput = hWritePipe;
	si.hStdError = hErrWritePipe;
	si.hStdInput = INVALID_HANDLE_VALUE;
	PROCESS_INFORMATION pi;
	memset(&pi, NULL, sizeof(pi));
	if (!::CreateProcess(NULL, cmd2, &sa, NULL, TRUE, DETACHED_PROCESS, NULL, currentDir, &si, &pi)) {
		CString base;
		base.LoadString(IDS_STRING_CANNOT_EXECUTE);
		CString msg;
		msg.Format(base, cmd);
		AfxMessageBox(msg, MB_OK | MB_ICONEXCLAMATION);
		::CloseHandle(hWritePipe);
		::CloseHandle(hReadPipe);
		::CloseHandle(hErrWritePipe);
		::CloseHandle(hErrReadPipe);
		delete [] cmd2;
		return FALSE;
	}

	DWORD out = 0, ret;
	const unsigned int buflen = sizeof(m_OutBuf) - 1;
	while ((ret = ::WaitForSingleObject(pi.hProcess, 0)) != WAIT_ABANDONED) {
		// R\[̏o͓e擾邽߂̃[v

		memset(m_OutBuf, NULL, sizeof(m_OutBuf));
		::PeekNamedPipe(hReadPipe, NULL, 0, NULL, &out, NULL);
		if (out > 0) {
			// Wo݂͂
			::ReadFile(hReadPipe, m_OutBuf, buflen, &out, NULL);
			Display();
		}
		memset(m_OutBuf, NULL, sizeof(m_OutBuf));
		::PeekNamedPipe(hErrReadPipe, NULL, 0, NULL, &out, NULL);
		if (out > 0) {
			// G[o݂͂
			::ReadFile(hErrReadPipe, m_OutBuf, buflen, &out, NULL);
			Display();
		}
		// ܂bZ[W
		MSG msg;
		if (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		if (ret == WAIT_OBJECT_0) {		// R\[Av͏I
			break;
		}
	}
	TRACE(_T("command \"%s\" has terminated.\n"), cmd);

	::GetExitCodeProcess(pi.hProcess, &m_ExitCode);
	::CloseHandle(pi.hProcess);
	::CloseHandle(pi.hThread);
	::CloseHandle(hWritePipe);
	::CloseHandle(hReadPipe);
	::CloseHandle(hErrWritePipe);
	::CloseHandle(hErrReadPipe);
	delete [] cmd2;

	return TRUE;
}

VOID CConsoleView::Display(VOID)
{
	CEdit &edit = GetEditCtrl();
	edit.SetSel(-1, -1);

	// sR[h̒
	memset(m_OutBuf2, NULL, sizeof(m_OutBuf2));
	LPSTR p1 = m_OutBuf;
	LPSTR p2 = m_OutBuf2;
	while (*p1) {
		if (*p1 == '\n' && m_LastChar != '\r') {
			*(p2++) = '\r';
		}
		if (m_LastChar == '\r' && *p1 != '\n') {
			*(p2++) = '\n';
		}
		m_LastChar = *p1;
		*(p2++) = *(p1++);
	}

#ifndef _UNICODE
	edit.ReplaceSel(m_OutBuf2);
#else
	memset(m_FormatBufW, NULL, sizeof(m_FormatBufW));
	::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, m_OutBuf2, -1, m_FormatBufW, sizeof(m_FormatBufW));
	edit.ReplaceSel(m_FormatBufW);
#endif
}

void CConsoleView::OnEnChange()
{
	// TODO :  ꂪ RICHEDIT Rg[̏ꍇA܂ACEditView::OnInitDialog() ֐I[o[ChāA
	// OR Ԃ ENM_CORRECTTEXT tO}XNɓāA
	// CRichEditCtrl().SetEventMask() ĂяoȂA
	// Rg[́A̒ʒm𑗐M܂B

	// TODO :  ɃRg[ʒmnh R[hǉĂB
}
