// DullSense.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "DullSense.h"
#include ".\dullsense.h"
#include <afxtempl.h>
#include <new>
#include "Values.h"

#define COMPARE_DIFFERENT		0		// 2͈قȂ
#define COMPARE_IDENTICAL		1		// ̑召2͈v
#define COMPARE_IDENTICAL_EXACT	2		// ̑召܂߂2͈v

using namespace std;

// CDullSense

IMPLEMENT_DYNAMIC(CDullSense, CListBox)
CDullSense::CDullSense() : m_pParentView(NULL), m_SelectingFlag(FALSE), m_IsTeXCommand(FALSE)
{
	LoadFunctionDic();
	LoadBeginEnd();
	m_LabelRef.RemoveAll();
}

CDullSense::~CDullSense()
{
	m_TeXFunctions.RemoveAll();
	m_BeginEnd.RemoveAll();
	m_LabelRef.RemoveAll();
	m_pParentView = NULL;
	m_SelectingFlag = FALSE;
}


BEGIN_MESSAGE_MAP(CDullSense, CListBox)
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()



int CDullSense::MySetCurSel(int nSelect, BOOL update)
{
	SetRedraw(FALSE);
	ShowScrollBar(SB_VERT, FALSE);
	int ret = SetCurSel(nSelect);
	if (update) {
		SetRedraw(TRUE);
		ShowScrollBar(SB_VERT, TRUE);
		Invalidate();
	}
	return ret;
}

// TeX̊֐ꗗǂݍ
VOID CDullSense::LoadFunctionDic(void)
{
	m_TeXFunctions.RemoveAll();

	// ֐t@C̐΃pX擾
	LPCTSTR appPath = theApp.GetAppPath();
	CString dicFileName;
	if (appPath) {
		dicFileName.Format(_T("%s\\%s"), appPath, TEX_FUNCTION_DIC);
	} else {
		dicFileName.Format(_T(".\\%s"), TEX_FUNCTION_DIC);
	}

	// t@Cǂݍ݁A͂
	TRY {
		CStdioFile dicFile(dicFileName, CFile::modeRead | CFile::shareDenyWrite | CFile::typeText | CFile::osSequentialScan);
		CString line;
		while (dicFile.ReadString(line)) {
			// ^u͋󔒂ɕϊĂ
			int index = line.Find(_T('\t'));
			while (index != -1) {
				line.SetAt(index, _T(' '));
				index = line.Find(_T('\t'), index);
			}
			// #̓RgƌȂ
			index = line.Find(_T('#'));
			if (index != -1) {
				line = line.Left(index);
			}
			// ]ȋ󔒂͎菜Ă
			line.TrimLeft();
			line.TrimRight();
			if (line.IsEmpty()) {	// ۂȂǂݔ΂
				continue;
			}


			// \
			index = line.Find(_T(' '));		// ŏ̋؂蕶
			if (index == -1) {		// @G[
				continue;
			}
			CString op = line.Left(index);	// Iy[^
			line = line.Right(line.GetLength() - index - 1);
			line.TrimLeft();
			index = line.Find(_T(' '));
			CString target, val;
			if (index != -1) {
				target = line.Left(index);
				val = line.Right(line.GetLength() - index - 1);
				val.TrimRight();
			} else {
				target = line;
				val.Empty();
			}
			if (op.CompareNoCase(_T("define")) == 0) {		// define
				if (m_TeXFunctions.FindFunction(target) == -1) {	// VKǉ
					CTeXFunctionType func(target);
					m_TeXFunctions.Add(func);
				}
				continue;
			}

			// targetXɃ\bhɕ
			CString target1, target2, target3;
			index = target.Find(_T('.'));
			if (index == -1) {	// @G[
				continue;
			}
			target1 = target.Left(index);
			target = target.Right(target.GetLength() - index - 1);
			index = target.Find(_T('.'));
			if (index == -1) {
				target2 = target;
				target3.Empty();
			} else {
				target2 = target.Left(index);
				target3 = target.Right(target.GetLength() - index - 1);
			}

			// set or add
			index = m_TeXFunctions.FindFunction(target1);
			if (index == -1) {	// ֐o^()
				continue;
			}
			CTeXFunctionType function = m_TeXFunctions.GetAt(index);
			if (op.CompareNoCase(_T("set")) == 0) {		// lZbg
				if (target2.CompareNoCase(_T("subparam")) == 0) {	// p[^
					function.EnableSubParam(_ttoi(val));
				}
				if (target2.CompareNoCase(_T("param")) == 0) {	// p[^
					if (target3.CompareNoCase(_T("count")) != 0) {	// @G[
						continue;
					}
					function.SetParamCount(_ttoi(val));
				}
			}
			if (op.CompareNoCase(_T("add")) == 0) {		// oǉ
				if (target2.CompareNoCase(_T("subparam")) == 0) {	// p[^
					if (!function.IsSubParamEnabled()) {	// p[^̂܂()
						continue;
					}
					function.AddSubParam(val);
				}
				if (target2.CompareNoCase(_T("param")) == 0) {	// p[^
					int i = _ttoi(target3) - 1;
					if (i < 0 || (UINT)i >= function.GetParamCount()) {	// CfbNXs
						continue;
					}
					function.AddParam(i, val);
				}
			}
			m_TeXFunctions.SetAt(index, function);
		}
		
		dicFile.Close();
	} CATCH (CFileException, e) {
		// G[Ă
	}
	END_CATCH
}

// Xgݒ肷(Ƃ̂paramCount>=1)
BOOL CDullSense::SetList(LPCTSTR funcName, int paramCount, BOOL subParam)
{
	ResetContent();		// XgNA

	if (!funcName) {	// TeX̊֐ꗗݒ肷
		UINT count = (UINT)m_TeXFunctions.GetCount();
		for (UINT i = 0; i < count; i++) {
			CString str = _T("\\");
			str += m_TeXFunctions.GetAt(i).GetFunctionName();
			AddString(str);
		}
		// #\̓ASY̊֌WŎǂݏoȂ
		AddString(_T("\\ "));
		AddString(_T("\\#"));
		// Ȋ֐Xgɒǉ
		AddString(_T("\\begin"));
		AddString(_T("\\def"));
		AddString(_T("\\end"));
		AddString(_T("\\eqref"));
		AddString(_T("\\label"));
		AddString(_T("\\newcommand"));
		AddString(_T("\\newenvironment"));
		AddString(_T("\\pageref"));
		AddString(_T("\\ref"));
		AddString(_T("\\renewcommand"));
		AddString(_T("\\renewenvironment"));
		AddString(_T("\\providecommand"));
		return TRUE;
	} else {
		if (!*funcName) {
			return FALSE;
		}
		if ((!_tcscmp(funcName, _T("begin")) || !_tcscmp(funcName, _T("end"))) && paramCount == 1) {
			UINT count = (UINT)m_BeginEnd.GetCount();
			for (UINT i = 0; i < count; i++) {
				AddString(m_BeginEnd[i]);
			}
			return TRUE;
		}
		if ((!_tcscmp(funcName, _T("label")) || !_tcscmp(funcName, _T("ref")) || !_tcscmp(funcName, _T("eqref")) || !_tcscmp(funcName, _T("pageref")))
			&& paramCount == 1) {
			SetLabelRef();
			UINT count = (UINT)m_LabelRef.GetCount();
			if (count == 0) {
				return FALSE;
			}
			for (UINT i = 0; i < count; i++) {
				AddString(m_LabelRef[i]);
			}
			return TRUE;
		}
		
		// W̊֐
		int index = m_TeXFunctions.FindFunction(funcName);
		if (index == -1) {
			return FALSE;
		}
		CTeXFunctionType function = m_TeXFunctions.GetAt(index);
		if (subParam) {		// p[^ŃXgAbv
			if (!function.IsSubParamEnabled()) {	// p[^݂Ȃ
				return FALSE;
			}
			UINT count = (UINT)function.GetSubParam().GetCount();
			if (count == 0) {	// p[^ۂɂ݂͑Ȃ
				return FALSE;
			}
			for (UINT i = 0; i < count; i++) {
				AddString(function.GetSubParam().GetAt(i));
			}
			return TRUE;
		}
		if (paramCount > 0) {	// p[^ŃXgAbv
			if ((UINT)paramCount > function.GetParamCount()) {	// p[^̃CfbNXs
				return FALSE;
			}
			UINT count = (UINT)function.GetParams(--paramCount).GetCount();
			if (count == 0) {
				return FALSE;
			}
			for (UINT i = 0; i < count; i++) {
				AddString(function.GetParams(paramCount).GetAt(i));
			}
			return TRUE;
		}
	}

	return FALSE;
}

// \begin, \end̈ꗗݒ肷
VOID CDullSense::LoadBeginEnd(void)
{
	m_BeginEnd.RemoveAll();

	// ֐t@C̐΃pX擾
	LPCTSTR appPath = theApp.GetAppPath();
	CString dicFileName;
	if (appPath) {
		dicFileName.Format(_T("%s\\%s"), appPath, BEGIN_END_DIC);
	} else {
		dicFileName.Format(_T(".\\%s"), BEGIN_END_DIC);
	}

	TRY {
		CStdioFile dicFile(dicFileName, CFile::modeRead | CFile::shareDenyWrite | CFile::typeText | CFile::osSequentialScan);
		CString line;

		while (dicFile.ReadString(line)) {
			// #̓RgƌȂ
			int index = line.Find(_T('#'));
			if (index != -1) {
				line = line.Left(index);
			}
			// ]ȋ󔒂͎菜Ă
			line.TrimLeft();
			line.TrimRight();
			if (line.IsEmpty()) {	// ۂȂǂݔ΂
				continue;
			}

			m_BeginEnd.Add(line);
		}

		dicFile.Close();
	} CATCH (CFileException, e) {
		// G[Ă
	}
	END_CATCH
}

BOOL CDullSense::SetNextChar(UINT ch, CString *complete)
{
	complete->Empty();
	CRichEditCtrl &richEditCtrl = m_pParentView->GetRichEditCtrl();
	long startPos, endPos;
	richEditCtrl.GetSel(startPos, endPos);

	if (!IsWindowVisible()) {	// ⊮₪\ĂȂ
		m_InputtedString.Empty();
#ifndef _UNICODE
		if (ch == _T('\\') && m_BackslashKeyDown) {
#else
		if (ch == _T('\\')) {	// ⊮Jn
#endif
			SetList();
			m_InputtedString += (TCHAR)ch;
			m_CompleteStartPos = endPos - 1;
			m_IsTeXCommand = TRUE;
			AppearWindow(TRUE);
			return FALSE;
		}
		if (ch == _T('{') || ch == _T('}') || ch == _T('[') || ch == _T(']') || ch == _T(',')) {
			CString buf;
			richEditCtrl.GetTextRange(0, endPos, buf);
			CString funcName;
			UINT paramIndex;
			BOOL isSubParam;
			Analyze(buf, &funcName, &paramIndex, &isSubParam);
			if (SetList(funcName, paramIndex, isSubParam)) {
				m_CompleteStartPos = endPos;
				m_IsTeXCommand = FALSE;
				AppearWindow(TRUE);
				return FALSE;
			}
		}
		return FALSE;
	}

	int sel = GetCurSel();
	if (ch == _T('\b')) {	// obNXy[X
		if ((!m_IsTeXCommand && (endPos < m_CompleteStartPos)) || (m_IsTeXCommand && (endPos <= m_CompleteStartPos))) {		// ⊮JnʒuOɖ߂
			AppearWindow(FALSE);
		} else {
			m_InputtedString = m_InputtedString.Left(m_InputtedString.GetLength() - 1);
			PlaceList();
			SelectItem();
		}
		return FALSE;
	}
	if (ch == _T('\r') || ch == _T('\n') /* ĝAs */ || ch == _T('\t')) {	// ⊮
		BOOL ret = FALSE;
		if (sel != LB_ERR) {
			GetText(sel, *complete);
			ret = TRUE;
		}
		AppearWindow(FALSE);
		return ret;
	}
	if (ch == _T('{') || ch == _T('}') || ch == _T('[') || ch == _T(']')
		|| ch == _T('(') || ch == _T(')') || ch == _T('\\') || ch == _T(',')
		|| ch == _T('.') || ch == _T('?') || ch == _T('!') || ch == _T(' ')) {
		if (sel != LB_ERR) {
			if (m_InputtedString[0] != _T('\\') || m_InputtedString.GetLength() != 1) {
				GetText(sel, *complete);
				*complete += (TCHAR)ch;
				AppearWindow(FALSE);
				return TRUE;
			}
		} else {
			AppearWindow(FALSE);
			// ̂ɂẮA߂ĕ⊮sKv
			return SetNextChar(ch, complete);
		}
	}

	m_InputtedString += (TCHAR)ch;
	PlaceList();
	SelectItem();

	return FALSE;
}

USHORT CDullSense::Compare(LPCTSTR s1, LPCTSTR s2, size_t *plen)
{
	// s1͍ςݕAs2Xg̒g
	size_t len1 = _tcslen(s1);
	size_t len2 = _tcslen(s2);
	if (plen) {
		*plen = len1;
	}
	if (len1 > len2) {
		return COMPARE_DIFFERENT;
	}
	if (!len1) {
		if (!len1 && !len2) {
			return COMPARE_IDENTICAL_EXACT;
		} else {
			return COMPARE_DIFFERENT;
		}
	}

	for (size_t i = 0; i < len1; i++) {
		if (_totupper(s1[i]) != _totupper(s2[i])) {	// قȂ
			return COMPARE_DIFFERENT;
		}
	}
	for (size_t i = 0; i < len1; i++) {
		if (s1[i] != s2[i]) {	// ̑召قȂ
			return COMPARE_IDENTICAL;
		}
	}

	return COMPARE_IDENTICAL_EXACT;
}

VOID CDullSense::SelectItem(VOID)
{
	if (m_InputtedString.IsEmpty()) {
		MySetCurSel(-1);
		return;
	}

	// r
	int identicalIndex = -1;
	size_t identicalLen = 0;
	int exactIndex = -1;
	size_t exactLen = 0;
	int count = GetCount();
	for (int i = 0; i < count; i++) {
		size_t len = 0;
		CString str;
		GetText(i, str);
		switch(Compare(m_InputtedString, str, &len)) {
			case COMPARE_IDENTICAL:
				if (len > identicalLen) {
					identicalLen = len;
					identicalIndex = i;
				}
				break;
			case COMPARE_IDENTICAL_EXACT:
				if (len > exactLen) {
					exactLen = len;
					exactIndex = i;
				}
				break;
		}
	}

	int sel = -1;
	if (exactIndex != -1) {
		sel = exactIndex;
	} else if (identicalIndex) {
		sel = identicalIndex;
	}
	if (sel != -1) {
		int dummy_sel = sel + (CANDIDATE_COUNT / 2);
		if (dummy_sel >= count) {
			dummy_sel = count;
		}
		MySetCurSel(dummy_sel, FALSE);	// ړǏ₪^񒆂ɕ\悤ɂ
	}
	MySetCurSel(sel);
}

VOID CDullSense::Analyze(LPCTSTR str, CString *funcName, UINT *paramIndex, BOOL *isSubParam)
{
	funcName->Empty();
	*paramIndex = 0;
	*isSubParam = FALSE;

	// Ō\oʒuT
	int b1 = 0;		// {̐
	int b2 = 0;		// [̐
	LPTSTR p = const_cast<LPTSTR>(str) + _tcslen(str);
	LPTSTR backslashPos0 = NULL, backslashPos1 = NULL;
	while (p > str && !backslashPos1) {
		p = _tcsdec(str, p);
		LPTSTR prev = _tcsdec(str, p);
		if (!prev || (prev && *prev != _T('\\'))) {
			int b;
			switch (*p) {
				case _T('{'):
					b1++;
					break;
				case _T('}'):
					b1--;
					break;
				case _T('['):
					b2++;
					break;
				case _T(']'):
					b2--;
					break;
				case _T('\\'):
					b = (b1 > b2) ? b1 : b2;
					if (b > 0) {
						backslashPos1 = p;
					} else {
						if (!backslashPos0) {
							backslashPos0 = p;
						}
					}
					break;
			}
		}
	}
	LPTSTR backslashPos = backslashPos1 ? backslashPos1 : backslashPos0;
	if (!backslashPos) {	// ݂Ȃ(̒ɂTeX֐݂͑Ȃ)
		return;
	}

	// ֐Eo
	LPTSTR tok = _tcsinc(backslashPos);
	if (!*tok) {	// \ŏIĂ
		return;
	}
	size_t size = _tcslen(tok) + 1;
	LPTSTR buf = NULL;
	try {
		buf = new TCHAR[size];
	} catch (bad_alloc xa) {
		return;
	}
	memset(buf, NULL, sizeof(TCHAR) * size);
	_tcscpy(buf, tok);
	tok = buf;
	while(*tok) {
		if (*tok == _T(' ')  || *tok == _T('\t') || *tok == _T('\r') || *tok == _T('\n')
			|| ((*tok == _T('{') || *tok == _T('[')) && tok != buf)) {
			TCHAR c = *tok;
			*tok = NULL;
			*funcName = buf;
			*tok = c;
			break;
		}
		tok = _tcsinc(tok);
	}

	LPTSTR posb1 = NULL;
	LPTSTR posb2 = NULL;
	b1 = b2 = 0;
	while (*tok) {
		if (b1 < 0 || b2 < 0) {	// ʂ̑ΉƂĂȂ
			break;
		}
		if (!b1 && !b2 && *tok != _T(' ') && *tok != _T('\t') && *tok != _T('\r') && *tok != _T('\n') && *tok != _T('{') && *tok != _T('[')) {	// `FbN
			break;
		}
		if (*tok == _T('{')) {
			if (!b1 && !b2) {
				(*paramIndex)++;
				posb1 = tok;
			}
			b1++;
		} else if (*tok == _T('}')) {
			b1--;
		} else if (*tok == _T('[')) {
			if (!b1 && !b2) {
				posb2 = tok;
			}
			b2++;
		} else if (*tok == _T(']')) {
			b2--;
		}
		tok = _tcsinc(tok);
	}
	if (!b1 || !posb1) {
		*paramIndex = 0;
	}
	if (b2 && posb2) {
		*isSubParam = TRUE;
	}
	if (*paramIndex && *isSubParam) {
		if (posb1 < posb2) {
			*paramIndex = 0;
			*isSubParam = TRUE;
		} else {
			*isSubParam = FALSE;
		}
	}
	delete [] buf;
}

VOID CDullSense::SetLabelRef(VOID)
{
	m_LabelRef.RemoveAll();

	// ͍ς݃eLXg擾
	CRichEditCtrl &richEditCtrl = m_pParentView->GetRichEditCtrl();
	CStringEx str;
	richEditCtrl.GetTextRange(0, richEditCtrl.GetTextLength(), str);
	RemoveComment(&str);

	// ݂̃J[\ʒu擾
	long caretStartPos, caretEndPos;
	richEditCtrl.GetSel(caretStartPos, caretEndPos);
	const int caretPos = static_cast<const int>(caretEndPos - 1);

	// Ώ
	CStringArray keys;
	keys.RemoveAll();
	keys.Add(_T("\\label"));
	keys.Add(_T("\\ref"));
	keys.Add(_T("\\eqref"));
	keys.Add(_T("\\pageref"));
	const UINT keyCount(static_cast<const UINT>(keys.GetCount()));

	// [v
	for (UINT i = 0; i < keyCount; ++i) {
		CString k(keys.GetAt(i));
		int keyPos(0);
		while((keyPos = str.FindString(k, keyPos)) != -1) {
			// ꍇ́A֐SɈv邩ǂׂ
			keyPos += k.GetLength();
			int index(str.GetFirstIndexExcluding(_T(" \t\r\n"), keyPos));
			if (index == -1) {
				index = keyPos;
			}
			if (str.GetAt(index) != _T('{') || index == caretPos) {		// {łȂÃ݂J[\ʒuł΂N_Ɏ̒n_T
				continue;
			}
			if ((index = str.GetNextIndex(index)) == -1) {		// Ō܂Ō
				break;
			}
			int labelStartPos(index);
			// I[ } T
			int labelEndPos(index - 1), brackets(1);
			do {
				TCHAR ch(str.GetAt(index));
				if (ch == _T('{')) {
					++brackets;
				} else if (ch == _T('}')) {
					if (--brackets == 0) {		// } 𔭌
						break;
					}
				} else if (ch == _T('\r') || ch == _T('\n')) {	// \r  \n ȂO܂łxƂ
					break;
				}
				labelEndPos = index;
			} while ((index = str.GetNextIndex(index)) != -1);
			keyPos = labelEndPos;
			CString buf(str.Mid(labelStartPos, labelEndPos - labelStartPos + 1));
			buf.Trim();
			if (!buf.IsEmpty() && m_LabelRef.Find(buf) == -1) {
				m_LabelRef.Add(buf);
			}
		}
	}
}

VOID CDullSense::PlaceList(VOID)
{
	CRichEditCtrl &richEditCtrl = m_pParentView->GetRichEditCtrl();
	long startPos, endPos;
	richEditCtrl.GetSel(startPos, endPos);
	CPoint caretPos = richEditCtrl.PosFromChar(endPos);
	CRect parentRect;
	m_pParentView->GetClientRect(&parentRect);
	// J[\̉ɕ\\?
	m_Rect.MoveToY(caretPos.y + m_Pitch);
	if (m_Rect.bottom > parentRect.bottom) {		// J[\̉ɕ\ƁA͂ݏo
		m_Rect.MoveToY(caretPos.y - m_Rect.Height());
		if (m_Rect.top < parentRect.top) {	// J[\̏ɕ\ƁA͂ݏo
			m_Rect.MoveToY(parentRect.top + (parentRect.Height() - m_Rect.Height()) / 2);
		}
	}
	// J[\̉Eɕ\\?
	m_Rect.MoveToX(caretPos.x + CANDIDATE_CARET_BIAS);
	if (m_Rect.right > parentRect.right) {		// J[\̉Eɕ\ƁA͂ݏo
		CClientDC dc(this);
		TEXTMETRIC metrics;
		dc.GetTextMetrics(&metrics);
		m_Rect.MoveToX(caretPos.x - m_Rect.Width() - metrics.tmMaxCharWidth);
	}
	SetWindowPos(&wndTop, m_Rect.left, m_Rect.top, m_Rect.Width(), m_Rect.Height(), SWP_DRAWFRAME | SWP_SHOWWINDOW);
}

VOID CDullSense::RemoveComment(CStringEx *str)
{
	int startPos, endPos, index(0), index2;

	// % ɂAsPʂ̃RgAEg
	while ((index = str->Find(_T('%'), index)) != -1) {
		index2 = str->GetBeforeIndex(index);
		if (index2 != -1 && str->GetAt(index2) == _T('\\')) {	// \%
			index2 = str->GetNextIndex(index);
			if (index2 == -1) {
				break;
			} else {
				index = index2;
				continue;
			}
		}
		startPos = endPos = index;
		TCHAR ch;
		while ((index = str->GetNextIndex(index)) != -1) {
			endPos = index;
			ch = str->GetAt(index);
			if (ch == _T('\r') || ch == _T('\n')) {
				break;
			}
		}
		if (str->Delete(startPos, endPos - startPos + 1) <= startPos) {		// Ō
			break;
		} else {
			index = startPos;
		}
	}

	// \if01 ɂRgAEg
	index = 0;
	LPCTSTR IF_STR(_T("\\if01"));
	LPCTSTR FI_STR(_T("\\fi"));
	while((index = FindTeXCommand(*str, IF_STR, index)) != -1) {
		startPos = index;
		index = FindTeXCommand(*str, FI_STR, index + static_cast<int>(_tcslen(IF_STR)));
		if (index == -1) {
			endPos = str->GetLength();
		} else {
			endPos = index + static_cast<int>(_tcslen(FI_STR));
		}
		if (str->Delete(startPos, endPos - startPos) <= startPos) {		// Ō
			break;
		} else {
			index = startPos;
		}
	}

	// \begin{comment} ɂRgAEg
	index = 0;
	LPCTSTR COMMENT_STR(_T("comment"));
	while ((index = FindTeXEnvironment(*str, TRUE, COMMENT_STR, index)) != -1) {
		startPos = index;
		FindTeXEnvironment(*str, FALSE, COMMENT_STR, index, &endPos);
		if (str->Delete(startPos, endPos - startPos + 1) <= startPos) {		// Ō
			break;
		} else {
			index = startPos;
		}
	}
}

int CDullSense::FindTeXCommand(const CString &source, LPCTSTR str, int iStart)
{
	const int len(source.GetLength());
	if (iStart < 0 || iStart >= len) {
		return -1;
	}

	int ret, index(iStart);
	while ((ret = source.Find(str, index)) != -1) {
		index = ret + static_cast<int>(_tcslen(str));
		if (index >= len) {
			break;
		}
		TCHAR ch(source.GetAt(index));
		if (ch == _T(' ') || ch == _T('\t') || ch == _T('\r') || ch == _T('\n')
			|| ch == _T('{') || ch == _T('}') || ch == _T('[') || ch == _T(']')
			|| ch == _T('(') || ch == _T(')') || ch == _T('\\') || ch == _T(',')) {
			break;
		}
	}
	return ret;
}

int CDullSense::FindTeXEnvironment(const CStringEx &source, BOOL flag, LPCTSTR str, int iStart, int *lastPos)
{
	const int len(source.GetLength());
	if (lastPos) {
		*lastPos = len - 1;
	}
	if (iStart < 0 || iStart >= len) {
		return -1;
	}

	LPCTSTR ENV_STR(flag ? _T("\\begin") : _T("\\end"));
	int ret, index(iStart);
	LPCTSTR TOK_STR(_T(","));
	while ((ret = source.Find(ENV_STR, index)) != -1) {
		if ((index = source.GetFirstIndexExcluding(_T(" \t\r\n"), ret + static_cast<int>(_tcslen(ENV_STR)))) == -1) {
			ret = -1;
			break;
		}
		if (source.GetAt(index) != _T('{')) {
			continue;
		} else if ((index = source.GetNextIndex(index)) == -1) {
			ret = -1;
			break;
		}
		int startPos(index), endPos(index - 1), brackets(1);
		do {
			TCHAR ch(source.GetAt(index));
			if (ch == _T('{')) {
				++brackets;
			} else if (ch == _T('}')) {
				if (--brackets == 0) {
					if (lastPos) {
						*lastPos = index;
					}
					break;
				}
			}
			endPos = index;
		} while ((index = source.GetNextIndex(index)) != -1);
		CString workStr(source.Mid(startPos, endPos - startPos + 1));
		workStr.Trim();
		int pos(0);
		CString tok(workStr.Tokenize(TOK_STR, pos));
		tok.Trim();
		while (!tok.IsEmpty()) {
			if (tok == str) {
				break;
			}
			tok = workStr.Tokenize(TOK_STR, pos);
			tok.Trim();
		}
		if (!tok.IsEmpty()) {
			break;
		} else {
			index = startPos;
		}
	}
	return ret;
}

VOID CDullSense::AppearWindow(BOOL state)
{
	if (!state) {	// ꗗ
		ShowWindow(SW_HIDE);
		EnableWindow(FALSE);
		m_IsTeXCommand = FALSE;
		return;
	}


	// ꗗ\
	m_Rect = CRect(0, 0, 0, 0);
	CClientDC dc(this);
	TEXTMETRIC metrics;
	dc.GetTextMetrics(&metrics);
	m_Pitch = metrics.tmHeight + metrics.tmExternalLeading;
	// EBhE̕ƍvZ
	int count = GetCount();
	m_Rect.bottom = m_Rect.top + ((CANDIDATE_COUNT < count) ? CANDIDATE_COUNT : count) * m_Pitch;
	int maxLen = 0;
	for (int i = 0; i < count; i++) {
		int len = GetTextLen(i);
		if (len > maxLen) {
			maxLen = len;
		}
	}
	if (maxLen > CANDIDATE_LEN_MAX) {
		maxLen = CANDIDATE_LEN_MAX;
	}
	m_Rect.right = m_Rect.left + maxLen * metrics.tmAveCharWidth + CANDIDATE_HSPACE;

	EnableWindow(TRUE);
	PlaceList();
	SelectItem();
}

VOID CDullSense::ItemUpDown(BOOL down)
{
	int sel = GetCurSel();
	int count = GetCount();
	if (sel == LB_ERR) {
		sel = 0;
	} else if (down) {
		sel++;
	} else {
		sel--;
	}
	if (sel >= 0 && sel < count) {
		MySetCurSel(sel);
	}
}

VOID CDullSense::ItemPageBackNext(BOOL next)
{
	int sel = GetCurSel();
	if (sel == LB_ERR) {
		sel = 0;
	} else if (next) {
		sel += (CANDIDATE_COUNT + 1);
		int max = GetCount() - 1;
		if (sel > max) {
			sel = max;
		}
	} else {
		sel -= (CANDIDATE_COUNT + 1);
		if (sel < 0) {
			sel = 0;
		}
	}
	MySetCurSel(sel);
}

void CDullSense::OnSetFocus(CWnd* pOldWnd)
{
	// TODO : ɃbZ[W nh R[hǉ܂B
	if (m_SelectingFlag) {
		CListBox::OnSetFocus(pOldWnd);
	} else {
		// KeEBhE(m_pParentView)ɃtH[JX悤ɂ
		const_cast<CRichEditView *>(m_pParentView)->SetFocus();
	}
}

void CDullSense::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	m_SelectingFlag = TRUE;
	SetFocus();
	CListBox::OnLButtonDblClk(nFlags, point);
	m_SelectingFlag = FALSE;
	SetFocus();

	// _uNbŃA^uƓɈ
	WPARAM wParam = (WPARAM)_T('\t');
	const_cast<CRichEditView *>(m_pParentView)->SendMessage(WM_CHAR, wParam);
}

void CDullSense::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	m_SelectingFlag = TRUE;
	SetFocus();
	CListBox::OnLButtonDown(nFlags, point);
	m_SelectingFlag = FALSE;
	SetFocus();
}
