// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

#include "TeXFunctionArray.h"
#include "StringArrayEx.h"
#include "StringEx.h"

// CDullSense

class CDullSense : public CListBox
{
	DECLARE_DYNAMIC(CDullSense)

private:
	CTeXFunctionArray m_TeXFunctions;		// TeX̊֐ێ
	CStringArrayEx m_BeginEnd;				// \begin, \end̃p[^
	CStringArrayEx m_LabelRef;				// \label, \ref̃p[^
	CString m_InputtedString;				// ͂ꂽ
	long m_Pitch;							// s
	const CRichEditView *m_pParentView;		// eEBhEւ̃|C^
	long m_CompleteStartPos;				// ⊮Jnʒu
	CRect m_Rect;							// ̋`̈
	BOOL m_SelectingFlag;					// }EXɂI
#ifndef _UNICODE
	BOOL m_BackslashKeyDown;				// \L[ꂽǂ
#endif
	BOOL m_IsTeXCommand;					// TeXR}h͒ǂ

	int MySetCurSel(int nSelect, BOOL update = TRUE);
	// TeX̊֐ꗗǂݍ
	VOID LoadFunctionDic(void);
	// \begin, \end̈ꗗǂݍ
	VOID LoadBeginEnd(void);
	// ͂ꂽɍ킹āAڂIԂɂ
	VOID SelectItem(VOID);
	// ̔r(Ẑ͓ƌȂ)
	static USHORT Compare(LPCTSTR s1, LPCTSTR s2, size_t *plen = NULL);		// ԒlDullSense.cppɂ
	// Xgݒ肷
	BOOL SetList(LPCTSTR funcName = NULL, int paramCount = 0, BOOL subParam = FALSE);
	// ^ꂽ͂āA\Ŏn܂֐Ǝp[^̃CfbNX܂͕p[^̗Lɕ
	static VOID Analyze(LPCTSTR str, CString *funcName, UINT *paramIndex, BOOL *isSubParam);
	// \label, \ref̈ꗗݒ肷
	VOID SetLabelRef(VOID);
	// ꗗK؂Ȉʒuɕ\
	VOID PlaceList(VOID);
	// RgΏۂ珜O
	static VOID RemoveComment(CStringEx *str);
	// TeX R}hT
	static int FindTeXCommand(const CString &source, LPCTSTR str, int iStart = 0);
	// T (TRUE = begin, FALSE = end)
	static int FindTeXEnvironment(const CStringEx &source, BOOL flag, LPCTSTR str, int iStart = 0, int *lastPos = NULL);

public:
	CDullSense();
	virtual ~CDullSense();

protected:
	DECLARE_MESSAGE_MAP()
public:
#ifndef _UNICODE
	VOID SetBackslashKeyDown(BOOL isDown)
	{
		m_BackslashKeyDown = isDown;
	}
#endif
	BOOL SetNextChar(UINT ch /* ͂ꂽ */, CString *complete /* ⊮镶 */);
	// eEBhEݒ肷
	VOID SetParentView(const CRichEditView *pParentView)
	{
		m_pParentView = pParentView;
	}
	// \邩ǂ
	VOID AppearWindow(BOOL state);
	// ⊮JnJ[\ʒu擾
	long GetCompleteStartPosition(VOID) const
	{
		return m_CompleteStartPos;
	}
	// ꗗ̑I㉺(TRUE = AFALSE = )
	VOID ItemUpDown(BOOL down);
	// ꗗ̑I擪܂͏I[ɂ(TRUE = I[AFALSE = 擪)
	VOID ItemTopBottom(BOOL bottom)
	{
		MySetCurSel((bottom) ? (GetCount() - 1) : 0);
	}
	// ꗗ̑I1y[WOシ(TRUE = iށAFALSE = ߂)
	VOID ItemPageBackNext(BOOL next);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
};


