// EncodingDialog.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "EncodingDialog.h"
#include ".\encodingdialog.h"
#include "Values.h"

// CEncodingDialog _CAO

IMPLEMENT_DYNAMIC(CEncodingDialog, CDialog)
CEncodingDialog::CEncodingDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CEncodingDialog::IDD, pParent), m_Encoding(ENCODING_SHIFTJIS | LFCODE_CRLF)
{
}

CEncodingDialog::~CEncodingDialog()
{
}

void CEncodingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ENCODE_LIST, m_EncodeList);
	DDX_Control(pDX, IDC_ENCODING_WITHBOM, m_WithBom);
}


BEGIN_MESSAGE_MAP(CEncodingDialog, CDialog)
	ON_CBN_SELCHANGE(IDC_ENCODE_LIST, OnCbnSelchangeEncodeList)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

BOOL CEncodingDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ
	// R{{bNXɁA\ȕGR[fBOǉ
	m_EncodeList.ResetContent();
	m_EncodeList.AddString(_T("VtgJIS"));
	m_EncodeList.AddString(_T("EUC-JP"));
	m_EncodeList.AddString(_T("ISO-2022-JP"));
	m_EncodeList.AddString(_T("UTF-8"));
	m_EncodeList.AddString(_T("UTF-16 (Little endian)"));
	m_EncodeList.AddString(_T("UTF-16 (Big endian)"));

	int sel = 0;
	BOOL check_enable = FALSE;
	if (m_Encoding & ENCODING_SHIFTJIS) {
		sel = 0;
		check_enable = FALSE;
	}
	if (m_Encoding & ENCODING_EUCJP) {
		sel = 1;
		check_enable = FALSE;
	}
	if (m_Encoding & ENCODING_ISO2022JP) {
		sel = 2;
		check_enable = FALSE;
	}
	if (m_Encoding & ENCODING_UTF8) {
		sel = 3;
		check_enable = TRUE;
	}
	if (m_Encoding & ENCODING_UTF16LE) {
		sel = 4;
		check_enable = TRUE;
	}
	if (m_Encoding & ENCODING_UTF16BE) {
		sel = 5;
		check_enable = TRUE;
	}
	if (sel < 3 && (m_Encoding & ENCODING_WITHBOM)) {	// ̂UNICODEȊOBOM悤ɂȂĂ
		m_Encoding &= (~ENCODING_WITHBOM);
	}
	BOOL check = FALSE;
	if (sel >= 3) {
		check = TRUE;
	}
    m_EncodeList.SetCurSel(sel);
	m_WithBom.SetCheck(check);
	m_WithBom.EnableWindow(check_enable);

	USHORT lf = LFCODE(m_Encoding);
	int id = 0;
	if (lf == LFCODE_LF) {
		id = IDC_ENCODING_LF_LF;
	}
	if (lf == LFCODE_CRLF) {
		id = IDC_ENCODING_LF_CRLF;
	}
	if (lf == LFCODE_CR) {
		id = IDC_ENCODING_LF_CR;
	}
	CButton *button = (CButton *)GetDlgItem(id);
	button->SetCheck(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CEncodingDialog::OnCbnSelchangeEncodeList()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	int sel = m_EncodeList.GetCurSel();
	if (sel != CB_ERR) {
		if (sel < 3) {
			m_WithBom.EnableWindow(FALSE);
		} else {
			m_WithBom.EnableWindow(TRUE);
		}
	}
}

void CEncodingDialog::OnBnClickedOk()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	// ݒ肳ꂽe擾
	UpdateData(TRUE);		// Ô?
	USHORT newEncoding = ENCODING_SHIFTJIS;
	int sel = m_EncodeList.GetCurSel();
	switch (sel) {
		case 0:
			newEncoding = ENCODING_SHIFTJIS;
			break;
		case 1:
			newEncoding = ENCODING_EUCJP;
			break;
		case 2:
			newEncoding = ENCODING_ISO2022JP;
			break;
		case 3:
			newEncoding = ENCODING_UTF8;
			break;
		case 4:
			newEncoding = ENCODING_UTF16LE;
			break;
		case 5:
			newEncoding = ENCODING_UTF16BE;
			break;
	}
	if (sel != CB_ERR && sel >= 3) {
		if (m_WithBom.GetCheck()) {
			newEncoding |= ENCODING_WITHBOM;
		}
	}
	CButton *radioLF = (CButton *)GetDlgItem(IDC_ENCODING_LF_LF);
	CButton *radioCR = (CButton *)GetDlgItem(IDC_ENCODING_LF_CR);
	if (radioLF->GetCheck()) {
		newEncoding |= LFCODE_LF;
	} else if (radioCR->GetCheck()) {
		newEncoding |= LFCODE_CR;
	} else {
		newEncoding |= LFCODE_CRLF;
	}

	m_Encoding = newEncoding;

	OnOK();
}
