// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "StdAfx.h"
#include ".\stringex.h"

using namespace std;


int CStringEx::FindString(LPCTSTR str, int iStart) const
{
	if (iStart >= GetLength() || iStart < 0) {
		return -1;
	}
	return Find(str, iStart);
}

int CStringEx::GetNextIndex(int index) const
{
	if (index + 1 >= GetLength() || index < 0) {
		return -1;
	}
	LPCTSTR p(operator LPCTSTR());
	LPTSTR q(_tcsinc(p + index));
	int ret(static_cast<int>(q - p));
	return (ret >= GetLength()) ? -1 : ret;
}

int CStringEx::GetBeforeIndex(int index) const
{
	if (index <= 0) {
		return -1;
	}
	LPCTSTR p(operator LPCTSTR());
	LPTSTR q(_tcsdec(p, p + index));
	return (q == NULL) ? -1 : static_cast<int>(q - p);
}

int CStringEx::GetFirstIndexExcluding(LPCTSTR charSet, int iStart) const
{
	const int len(GetLength());
	if (iStart >= len || iStart < 0) {
		return -1;
	}
	int ret(static_cast<int>(_tcsspn(operator LPCTSTR() + iStart, charSet)) + iStart);
	return (ret >= len) ? -1 : ret;
}
