// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

class CTeXFunctionType
{
private:
	UINT m_ParamCount;				// p[^̐
	CStringArray *m_pParams;		// p[^̃Xg(z)
	CStringArray *m_pSubParam;		// p[^̃Xgւ̃|C^
	CString m_FunctionName;			// ֐̖O

public:
	CTeXFunctionType(void);
	CTeXFunctionType(LPCTSTR funcname);
	CTeXFunctionType(const CString &funcname);
	CTeXFunctionType(const CTeXFunctionType &obj);		// Rs[RXgN^
	virtual ~CTeXFunctionType(void);
	virtual BOOL Copy(const CTeXFunctionType &obj);		// IuWFNgRs[
	VOID SetFunctionName(LPCTSTR funcname)				// ̊֐̖Oݒ肷
	{
		m_FunctionName = funcname;
	}
	VOID SetFunctionName(const CString &funcname)
	{
		m_FunctionName = funcname;
	}
	BOOL SetParamCount(UINT count);						// p[^̐ݒ
	BOOL EnableSubParam(BOOL enable = TRUE);			// p[^L/ɂ
	LPCTSTR GetFunctionName(VOID) const					// ̊֐̖O擾
	{
		return m_FunctionName;
	}
	UINT GetParamCount(VOID) const						// p[^̐擾
	{
		return m_ParamCount;
	}
	BOOL IsSubParamEnabled(VOID) const					// p[^LɂȂĂ邩ǂ
	{
		return m_pSubParam ? TRUE : FALSE;
	}
	UINT AddParam(UINT index, LPCTSTR str)				// p[^ɒǉ
	{
		ASSERT (index < m_ParamCount);
		return (UINT)m_pParams[index].Add(str);
	}
	UINT AddParam(UINT index, const CString &str)
	{
		ASSERT (index < m_ParamCount);
		return (UINT)m_pParams[index].Add(str);
	}
	UINT AddSubParam(LPCTSTR str)						// p[^ɒǉ
	{
		ASSERT (m_pSubParam);
		return (UINT)m_pSubParam->Add(str);
	}
	UINT AddSubParam(const CString &str)
	{
		ASSERT (m_pSubParam);
		return (UINT)m_pSubParam->Add(str);
	}
	virtual const CTeXFunctionType &operator=(const CTeXFunctionType &obj)
	{
		Copy(obj);
		return *this;
	}
	const CStringArray &GetParams(UINT index) const		// indexԖڂ̎p[^̃Xg擾
	{
		ASSERT (index < m_ParamCount);
		return m_pParams[index];
	}
	const CStringArray &GetSubParam(VOID) const			// p[^̃Xg擾
	{
		ASSERT (m_pSubParam);
		return *m_pSubParam;
	}
};
