// TeXnicianDoc.cpp : CTeXnicianDoc NX̎
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"

#include "TeXnicianDoc.h"
#include "CntrItem.h"
#include "Values.h"
#include ".\texniciandoc.h"
#include "EncodingDialog.h"
#include <new>
#include "nkf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

typedef int (CALLBACK *SETNKFOPTION)(LPCSTR optStr);
typedef BOOL (WINAPI *NKFCONVERTSAFE)(LPSTR outStr, DWORD nOutBufferLength, LPDWORD lpBytesReturned, LPCSTR inStr, DWORD nlnBufferLength);
typedef int (CALLBACK *NKFGETKANJICODE)(VOID);

#define NKF_OPTION_BUFFER_SIZE 256

// CTeXnicianDoc

IMPLEMENT_DYNCREATE(CTeXnicianDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CTeXnicianDoc, CRichEditDoc)
	//  OLE ReiLɂ܂B
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, CRichEditDoc::OnUpdateObjectVerbMenu)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVING_ENCODING, OnUpdateFileSavingEncoding)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_EUCJP, OnUpdateViewEncodingEucjp)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_ISO2022JP, OnUpdateViewEncodingIso2022jp)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_SHIFTJIS, OnUpdateViewEncodingShiftjis)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_UTF16BE, OnUpdateViewEncodingUtf16be)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_UTF16LE, OnUpdateViewEncodingUtf16le)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ENCODING_UTF8, OnUpdateViewEncodingUtf8)
	ON_COMMAND(ID_VIEW_ENCODING_EUCJP, OnViewEncodingEucjp)
	ON_COMMAND(ID_VIEW_ENCODING_ISO2022JP, OnViewEncodingIso2022jp)
	ON_COMMAND(ID_VIEW_ENCODING_SHIFTJIS, OnViewEncodingShiftjis)
	ON_COMMAND(ID_VIEW_ENCODING_UTF16BE, OnViewEncodingUtf16be)
	ON_COMMAND(ID_VIEW_ENCODING_UTF16LE, OnViewEncodingUtf16le)
	ON_COMMAND(ID_VIEW_ENCODING_UTF8, OnViewEncodingUtf8)
	ON_COMMAND(ID_FILE_SAVING_ENCODING, OnFileSavingEncoding)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_EXECUTE_PLATEX, OnExecutePlatex)
	ON_COMMAND(ID_EXECUTE_JBIBTEX, OnExecuteJbibtex)
	ON_COMMAND(ID_EXECUTE_DVIOUT, OnExecuteDviout)
	ON_COMMAND(ID_EXECUTE_DVIPS, OnExecuteDvips)
	ON_COMMAND(ID_EXECUTE_DVIPDFMX, OnExecuteDvipdfmx)
	ON_COMMAND(ID_EXECUTE_GSVIEW, OnExecuteGsview)
END_MESSAGE_MAP()


// CTeXnicianDoc RXgNV/fXgNV

CTeXnicianDoc::CTeXnicianDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	m_RawImage.image = NULL;
	m_RawImage.size = 0;
}

CTeXnicianDoc::~CTeXnicianDoc()
{
	if (m_RawImage.image) {
		delete [] m_RawImage.image;
	}
	m_RawImage.image = NULL;
	m_RawImage.size = NULL;
}

BOOL CTeXnicianDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	m_FileLoadEncoding = ENCODING_SHIFTJIS | LFCODE_CRLF;
	m_FileSaveEncoding = ENCODING_SHIFTJIS | LFCODE_CRLF;
	if (m_RawImage.image) {
		delete [] m_RawImage.image;
	}
	m_RawImage.image = NULL;
	m_RawImage.size = 0;

	return TRUE;
}
CRichEditCntrItem* CTeXnicianDoc::CreateClientItem(REOBJECT* preo) const
{
	return new CTeXnicianCntrItem(preo, const_cast<CTeXnicianDoc*>(this));
}




// CTeXnicianDoc VA

void CTeXnicianDoc::Serialize(CArchive& ar)
{
	if (m_RawImage.image) {		// obt@NA
		delete [] m_RawImage.image;
	}
	m_RawImage.image = NULL;
	m_RawImage.size = 0;

	if (ar.IsStoring())
	{
		// TODO: i[R[hɒǉĂB
		SetTeXFileData(ar.GetFile());
		CRichEditView *pRichEditView = GetView();		// RichEditView擾
#ifndef _UNICODE
		UINT size = (UINT)pRichEditView->GetWindowTextLength() + 1;
		LPSTR pbuf = NULL;
		try {
			pbuf = new CHAR[size];		// f[^i[obt@m
		} catch (bad_alloc xa) {
			AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_SAVING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
			goto resume_point;
		}
		memset(pbuf, NULL, size);
		pRichEditView->GetWindowText(pbuf, size);
#else
		// UNICODE\SJISɕϊĂ
		UINT wsize = (UINT)pRichEditView->GetWindowTextLength() + 1;
		LPWSTR pwbuf = NULL;
		try {
			pwbuf = new WCHAR[wsize];
		} catch (bad_alloc xa) {
			AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_SAVING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
			goto resume_point;
		}
		memset(pwbuf, NULL, sizeof(WCHAR) * wsize);
		pRichEditView->GetWindowText(pwbuf, wsize);
		wsize--;
		UINT size = (UINT)::WideCharToMultiByte(CP_OEMCP, 0, pwbuf, wsize, NULL, 0, NULL, NULL) + 1;
		LPSTR pbuf = NULL;
		try {
			pbuf = new CHAR[size];
		} catch (bad_alloc xa) {
			AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_SAVING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
			delete [] pwbuf;
			goto resume_point;
		}
		memset(pbuf, NULL, size);
		::WideCharToMultiByte(CP_OEMCP, 0, pwbuf, wsize, pbuf, size, NULL, NULL);
		delete [] pwbuf;
#endif
		size--;

		HINSTANCE hnkf = theApp.GetNkfInstance();
		SETNKFOPTION pSetNkfOption = NULL;
		NKFCONVERTSAFE pNkfConvertSafe = NULL;
		if (hnkf) {
			pSetNkfOption = (SETNKFOPTION)GetProcAddress(hnkf, "SetNkfOption");
			pNkfConvertSafe = (NKFCONVERTSAFE)GetProcAddress(hnkf, "NkfConvertSafe");
			ASSERT(pSetNkfOption && pNkfConvertSafe);
		}
		if (!hnkf || !pSetNkfOption || !pNkfConvertSafe) {	// nkf32.dllpłȂꍇ
			ar.Write(pbuf, size);
		} else {	// nkf32.dllp\
			if (m_FileSaveEncoding == (ENCODING_SHIFTJIS | LFCODE_CRLF)) {	// ϊ̕KvȂ
				ar.Write(pbuf, size);
				delete [] pbuf;
				goto resume_point;
			}

			static CHAR options[NKF_OPTION_BUFFER_SIZE];
			memset(options, NULL, NKF_OPTION_BUFFER_SIZE);
			strcpy(options, "-S");
			if (m_FileSaveEncoding & ENCODING_SHIFTJIS) {
				strcat(options, " -s");
			}
			if (m_FileSaveEncoding & ENCODING_EUCJP) {
				strcat(options, " -e");
			}
			if (m_FileSaveEncoding & ENCODING_ISO2022JP) {
				strcat(options, " -j");
			}
			if (m_FileSaveEncoding & ENCODING_UTF8) {
				if (m_FileSaveEncoding & ENCODING_WITHBOM) {
					strcat(options, " -w8");
				} else {
					strcat(options, " -w");
				}
			}
			if (m_FileSaveEncoding & ENCODING_UTF16LE) {
				if (m_FileSaveEncoding & ENCODING_WITHBOM) {
					strcat(options, " -w16L");
				} else {
					strcat(options, " -w16L0");
				}
			}
			if (m_FileSaveEncoding & ENCODING_UTF16BE) {
				if (m_FileSaveEncoding & ENCODING_WITHBOM) {
					strcat(options, " -w16B");
				} else {
					strcat(options, " -w16B0");
				}
			}

			USHORT lfcode = LFCODE(m_FileSaveEncoding);
			if (lfcode == LFCODE_LF) {
				strcat(options, " -Lu");
			}
			if (lfcode == LFCODE_CRLF) {
				strcat(options, " -Lw");
			}
			if (lfcode == LFCODE_CR) {
				strcat(options, " -Lm");
			}

			pSetNkfOption(options);

			DWORD ret = 0, conv_size = 0;
			if (!pNkfConvertSafe(NULL, 0, &conv_size, pbuf, size)) {
				// R[hϊɎsꍇ́Â܂ܕۑ
				ar.Write(pbuf, size);
				AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
				delete [] pbuf;
				goto resume_point;
			}
			LPSTR pconvbuf = NULL;
			try {
				pconvbuf = new CHAR[conv_size];
			} catch(bad_alloc xa) {
				AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_SAVING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
				delete [] pbuf;
				goto resume_point;
			}
			memset(pconvbuf, NULL, conv_size);
			if (!pNkfConvertSafe(pconvbuf, conv_size, &ret, pbuf, size)) {
				ar.Write(pbuf, sizeof(TCHAR) * (size - 1));
				AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
				delete [] pbuf;
				delete [] pconvbuf;
				goto resume_point;
			}
			ar.Write(pconvbuf, ret);
			delete [] pconvbuf;
		}
		delete [] pbuf;
	}
	else
	{
		// TODO: ǂݍރR[hɒǉĂB
		// Uǂݍރt@CVtgJISƉ肷
		m_FileLoadEncoding = ENCODING_SHIFTJIS | LFCODE_CRLF;

		CFile *pFile = ar.GetFile();
		m_RawImage.size = (UINT)pFile->GetLength();
		try {
			m_RawImage.image = new CHAR[m_RawImage.size];
		} catch (bad_alloc xa) {
			AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_LOADING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
			m_RawImage.image = NULL;
			m_RawImage.size = 0;
			goto resume_point;
		}
		memset(m_RawImage.image, NULL, m_RawImage.size);
		pFile->Read(m_RawImage.image, m_RawImage.size);

		CRichEditView *pRichEditView = GetView();		// RichEditView擾

		HINSTANCE hnkf = theApp.GetNkfInstance();
		SETNKFOPTION pSetNkfOption = NULL;
		NKFCONVERTSAFE pNkfConvertSafe = NULL;
		if (hnkf) {
			pSetNkfOption = (SETNKFOPTION)GetProcAddress(hnkf, "SetNkfOption");
			pNkfConvertSafe = (NKFCONVERTSAFE)GetProcAddress(hnkf, "NkfConvertSafe");
			ASSERT(pSetNkfOption && pNkfConvertSafe);
		}
		if (!hnkf || !pSetNkfOption || !pNkfConvertSafe) {	// nkf32.dllpłȂꍇ
#ifndef _UNICODE
			LPSTR pbuf = NULL;
			try {
				pbuf = new CHAR[m_RawImage.size + 1];
			} catch (bad_alloc xa) {
				AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_LOADING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
			memset(pbuf, NULL, m_RawImage.size + 1);
			memcpy(pbuf, m_RawImage.image, m_RawImage.size);
			pRichEditView->SetWindowText(pbuf);
			delete [] pbuf;
#else
			UINT wsize = (UINT)::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, m_RawImage.image, m_RawImage.size, NULL, 0) + 1;
			LPWSTR pwbuf = NULL;
			try {
				pwbuf = new WCHAR[wsize];
			} catch (bad_alloc xa) {
				AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_LOADING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
			memset(pwbuf, NULL, sizeof(WCHAR) * wsize);
			::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, m_RawImage.image, m_RawImage.size, pwbuf, wsize);
			pRichEditView->SetWindowText(pwbuf);
			delete [] pwbuf;
#endif
			pRichEditView->GetRichEditCtrl().SetSel(-1, -1);
			goto resume_point;
		} else {
			pSetNkfOption("-s -Lw");		// USJISɕϊ
			DWORD ret = 0, conv_size = 0;
			if (!pNkfConvertSafe(NULL, 0, &conv_size, m_RawImage.image, m_RawImage.size)) {
				AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
			conv_size++;
			LPSTR pconvbuf = NULL;
			try {
				pconvbuf = new CHAR[conv_size];
			} catch (bad_alloc xa) {
				AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_LOADING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
			memset(pconvbuf, NULL, conv_size);
			if (!pNkfConvertSafe(pconvbuf, conv_size, &ret, m_RawImage.image, m_RawImage.size)) {
				AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				delete [] pconvbuf;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
#ifndef _UNICODE
			pRichEditView->SetWindowText(pconvbuf);
#else
			conv_size--;
			// SJISUNICODE\ɕϊ
			UINT wsize = (UINT)::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pconvbuf, conv_size, NULL, 0) + 1;
			LPWSTR pwbuf = NULL;
			try {
				pwbuf = new WCHAR[wsize];
			} catch (bad_alloc xa) {
				AfxMessageBox(IDS_STRING_CANNOT_ALLOCATE_LOADING_BUFFER, MB_OK | MB_ICONEXCLAMATION);
				delete [] m_RawImage.image;
				delete [] pconvbuf;
				m_RawImage.image = NULL;
				m_RawImage.size = 0;
				goto resume_point;
			}
			memset(pwbuf, NULL, sizeof(WCHAR) * wsize);
			::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pconvbuf, conv_size, pwbuf, wsize);
			pRichEditView->SetWindowText(pwbuf);
			delete [] pwbuf;
#endif
			delete [] pconvbuf;
			pRichEditView->GetRichEditCtrl().SetSel(-1, -1);
			
			// ǂݍ񂾃t@C̕GR[fBO擾
			NKFGETKANJICODE pNkfGetKanjiCode = (NKFGETKANJICODE)GetProcAddress(hnkf, "NkfGetKanjiCode");
			ASSERT (pNkfGetKanjiCode);
			int code = pNkfGetKanjiCode();
			m_FileLoadEncoding = NKFTOENCODING (code);
			switch (code) {
				case 3:
					// oCgEI[_[E}[N̗L`FbN
					if (m_RawImage.size >= 3) {
						if (m_RawImage.image[0] == 0xFE && m_RawImage.image[1] == 0xBB && m_RawImage.image[2] == 0xBF) {	// oCgEI[_[E}[NL
							m_FileLoadEncoding |= ENCODING_WITHBOM;
						}
					}
					break;
				case 4:
					// oCgEI[_[E}[N̗L`FbN
					if (m_RawImage.size >= 2) {
						if (m_RawImage.image[0] == 0xFF && m_RawImage.image[1] == 0xFE) {	// oCgEI[_[E}[NL
							m_FileLoadEncoding |= ENCODING_WITHBOM;
						}
					}
					break;
				case 5:
					// oCgEI[_[E}[N̗L`FbN
					if (m_RawImage.size >= 2) {
						if (m_RawImage.image[0] == 0xFE && m_RawImage.image[1] == 0xFF) {	// oCgEI[_[E}[NL
							m_FileLoadEncoding |= ENCODING_WITHBOM;
						}
					}
					break;
			}
			m_FileLoadEncoding |= GetLFCode(m_RawImage.image, m_RawImage.size);
			m_FileSaveEncoding = m_FileLoadEncoding;
		}
	}

	// {NX $$DOC_BASE_CLASS$$ ĂяoƂɂăRei hLg
	// COleClientItem IuWFNg̃VAC[[V\ɂȂ܂B
	// TODO: eLXgƂăVAĂꍇ CRichEditDoc::m_bRTF = FALSE ɐݒ肵܂B
resume_point:
	SetModifiedFlag(FALSE);

//	CRichEditDoc::Serialize(ar);
}

USHORT CTeXnicianDoc::GetLFCode(LPCSTR buf, UINT bufsize)
{
	UINT i;
	for (i = 0; i < bufsize; i++) {		// ŏɏosT
		if (buf[i] == '\r' || buf[i] == '\n') {
			break;
		}
	}
	if (i >= bufsize) {
		// ftHgCRLF
		return LFCODE_CRLF;
	}
	if (buf[i] == '\n') {	// LF蓾Ȃ
		return LFCODE_LF;
	}
	if (++i >= bufsize) {	// ŏɏos\rŁAꂪŌ̕
		return LFCODE_CR;
	}
	if (buf[i] == '\n') {	// UTF-16ȊÓACRLF
		return LFCODE_CRLF;
	}
	if (buf[i] != '\0') {	// UTF-16ȊÓACR
		return LFCODE_CR;
	}
	// UTF-16̏ꍇ
	if (++i >= bufsize) {	// UTF-16CR
		return LFCODE_CR;
	}
	if (buf[i] == '\n') {	// UTF-16CRLF
		return LFCODE_CRLF;
	} else {
		return LFCODE_CR;
	}
}

// CTeXnicianDoc ff

#ifdef _DEBUG
void CTeXnicianDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CTeXnicianDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG


// CTeXnicianDoc R}h

void CTeXnicianDoc::OnUpdateFileSavingEncoding(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (!theApp.GetNkfInstance()) {		// nkf32.dllpłȂ̂ŁAɂ
		pCmdUI->Enable(FALSE);
	} else {
		pCmdUI->Enable(TRUE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingEucjp(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_EUCJP) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingIso2022jp(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_ISO2022JP) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingShiftjis(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_SHIFTJIS) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingUtf16be(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF16BE) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingUtf16le(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF16LE) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

void CTeXnicianDoc::OnUpdateViewEncodingUtf8(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF8) {
		pCmdUI->SetRadio(TRUE);
	} else {
		pCmdUI->SetRadio(FALSE);
	}
	if (theApp.GetNkfInstance() && m_RawImage.image && !IsModified()) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}
}

VOID CTeXnicianDoc::ChangeViewEncoding(USHORT kanjiCode)
{
	// \GR[fBOύX
	CRichEditView *pRichEditView = GetView();

	HINSTANCE hnkf = theApp.GetNkfInstance();
	ASSERT(hnkf);
	SETNKFOPTION pSetNkfOption = (SETNKFOPTION)GetProcAddress(hnkf, "SetNkfOption");
	NKFCONVERTSAFE pNkfConvertSafe = (NKFCONVERTSAFE)GetProcAddress(hnkf, "NkfConvertSafe");
	ASSERT(pSetNkfOption && pNkfConvertSafe);
	if (kanjiCode & ENCODING_SHIFTJIS) {
		pSetNkfOption("-S -s -Lw");
	}
	if (kanjiCode & ENCODING_EUCJP) {
		pSetNkfOption("-E -s -Lw");
	}
	if (kanjiCode & ENCODING_ISO2022JP) {
		pSetNkfOption("-J -s -Lw");
	}
	if (kanjiCode & ENCODING_UTF8) {
		pSetNkfOption("-W8 -s -Lw");
	}
	if (kanjiCode & ENCODING_UTF16LE) {
		pSetNkfOption("-W16L -s -Lw");
	}
	if (kanjiCode & ENCODING_UTF16BE) {
		pSetNkfOption("-W16B -s -Lw");
	}
	
	DWORD ret = 0, conv_size = 0;
	if (!pNkfConvertSafe(NULL, 0, &conv_size, m_RawImage.image, m_RawImage.size)) {
		AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	conv_size++;
	LPSTR pconvbuf = NULL;
	try {
		pconvbuf = new CHAR[conv_size];
	} catch (bad_alloc xa) {
		AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	memset(pconvbuf, NULL, conv_size);
	if (!pNkfConvertSafe(pconvbuf, conv_size, &ret, m_RawImage.image, m_RawImage.size)) {
		AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
		delete [] pconvbuf;
		return;
	}
	conv_size--;

#ifndef _UNICODE
	pRichEditView->SetWindowText(pconvbuf);
#else
	UINT wsize = (UINT)::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pconvbuf, conv_size, NULL, 0) + 1;
	LPWSTR pwbuf = NULL;
	try {
		pwbuf = new WCHAR[wsize];
	} catch (bad_alloc xa) {
		AfxMessageBox(IDS_STRING_KANJICODE_CONVERSION_FAILURE, MB_OK | MB_ICONEXCLAMATION);
		delete [] pconvbuf;
		return;
	}
	memset(pwbuf, NULL, sizeof(WCHAR) * wsize);
	::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pconvbuf, conv_size, pwbuf, wsize);
	pRichEditView->SetWindowText(pwbuf);
	delete [] pwbuf;
#endif
	delete [] pconvbuf;

	NKFGETKANJICODE pNkfGetKanjiCode = (NKFGETKANJICODE)GetProcAddress(hnkf, "NkfGetKanjiCode");
	ASSERT (pNkfGetKanjiCode);
	kanjiCode = NKFTOENCODING (pNkfGetKanjiCode());		// ۂ̕GR[fBO
	if (kanjiCode & ENCODING_UTF8) {
		if (m_RawImage.size >= 3) {
			if (m_RawImage.image[0] == 0xFE && m_RawImage.image[1] == 0xBB && m_RawImage.image[2] == 0xBF) {	// oCgEI[_[E}[NL
				kanjiCode |= ENCODING_WITHBOM;
			}
		}
	}
	if (kanjiCode & ENCODING_UTF16LE) {
		if (m_RawImage.size >= 2) {
			if (m_RawImage.image[0] == 0xFF && m_RawImage.image[1] == 0xFE) {	// oCgEI[_[E}[NL
				kanjiCode |= ENCODING_WITHBOM;
			}
		}
	}
	if (kanjiCode & ENCODING_UTF16BE) {
		if (m_RawImage.size >= 2) {
			if (m_RawImage.image[0] == 0xFE && m_RawImage.image[1] == 0xFF) {	// oCgEI[_[E}[NL
				kanjiCode |= ENCODING_WITHBOM;
			}
		}
	}

	m_FileLoadEncoding = LFCODE(m_FileLoadEncoding) | kanjiCode;
	m_FileSaveEncoding = m_FileLoadEncoding;
}

void CTeXnicianDoc::OnViewEncodingEucjp()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_EUCJP) {
		return;
	}
	ChangeViewEncoding(ENCODING_EUCJP);
}

void CTeXnicianDoc::OnViewEncodingIso2022jp()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_ISO2022JP) {
		return;
	}
	ChangeViewEncoding(ENCODING_ISO2022JP);
}


void CTeXnicianDoc::OnViewEncodingShiftjis()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_SHIFTJIS) {
		return;
	}
	ChangeViewEncoding(ENCODING_SHIFTJIS);
}

void CTeXnicianDoc::OnViewEncodingUtf16be()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF16BE) {
		return;
	}
	ChangeViewEncoding(ENCODING_UTF16BE);
}


void CTeXnicianDoc::OnViewEncodingUtf16le()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF16LE) {
		return;
	}
	ChangeViewEncoding(ENCODING_UTF16LE);
}

void CTeXnicianDoc::OnViewEncodingUtf8()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (m_FileLoadEncoding & ENCODING_UTF8) {
		return;
	}
	ChangeViewEncoding(ENCODING_UTF8);
}

void CTeXnicianDoc::OnFileSavingEncoding()
{
	// TODO : ɃR}h nh R[hǉ܂B
	CEncodingDialog dlg;
	dlg.SetNowEncoding(m_FileSaveEncoding);		// ݂̐ݒ\
	if (dlg.DoModal() == IDOK) {
		m_FileSaveEncoding = dlg.GetEncoding();
	}
}

void CTeXnicianDoc::OnFileSave()
{
	// TODO : ɃR}h nh R[hǉ܂B
	ClearTeXFileData();
	CRichEditDoc::OnFileSave();
}

VOID CTeXnicianDoc::SetTeXFileData(CFile *file)
{
//	m_TeXFileData.texFile = file->GetFileName();
//	m_TeXFileData.texFileNoExt = file->GetFileTitle();
// ꕔ̊ł́Ał͐Ȃ

	CString full = file->GetFilePath();
	// pX̋؂/\ɂ
	int i = full.Find(_T('/'));
	while (i != -1) {
		full.SetAt(i, _T('\\'));
		i = full.Find(_T('/'), i);
	}

	// pXƃt@Co
	i = full.ReverseFind(_T('\\'));
	if (i != -1) {
		m_TeXFileData.texFilePath = full.Left(i);
		m_TeXFileData.texFile = full.Right(full.GetLength() - i - 1);
	} else {
		m_TeXFileData.texFilePath.Empty();
		m_TeXFileData.texFile.Empty();
	}

	// gqt@Co
	i = m_TeXFileData.texFile.ReverseFind(_T('.'));
	if (i != -1) {
		m_TeXFileData.texFileNoExt = m_TeXFileData.texFile.Left(i);
	} else {
		m_TeXFileData.texFileNoExt = m_TeXFileData.texFile;
	}
	TRACE(_T("texFilePath = %s, texFile = %s, texFileNoExt = %s\n"), m_TeXFileData.texFilePath, m_TeXFileData.texFile, m_TeXFileData.texFileNoExt);
}

void CTeXnicianDoc::OnExecutePlatex()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnFileSave();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("platex"));
		CConsoleView *pconsole = theApp.GetConsoleView();
		pconsole->Clear();
		if (!pconsole->Execute(cmd.GetCommandLine(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath)) {
			ClearTeXFileData();
		}
	}
}

void CTeXnicianDoc::OnExecuteJbibtex()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnExecutePlatex();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("jbibtex"));
		CConsoleView *pconsole = theApp.GetConsoleView();
		if (!pconsole->Execute(cmd.GetCommandLine(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath)) {
			ClearTeXFileData();
		}
	}
}

void CTeXnicianDoc::OnExecuteDviout()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnExecutePlatex();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("dviout"));
		::ShellExecute(NULL, NULL, cmd.GetExeName(), cmd.GetOption(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath, SW_SHOWNORMAL);
	}
}

void CTeXnicianDoc::OnExecuteDvips()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnExecutePlatex();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("dvipsk"));
		CConsoleView *pconsole = theApp.GetConsoleView();
		if (!pconsole->Execute(cmd.GetCommandLine(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath)) {
			ClearTeXFileData();
		}
	}
}

void CTeXnicianDoc::OnExecuteDvipdfmx()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnExecutePlatex();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("dvipdfmx"));
		CConsoleView *pconsole = theApp.GetConsoleView();
		if (!pconsole->Execute(cmd.GetCommandLine(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath)) {
			ClearTeXFileData();
		}
	}
}

void CTeXnicianDoc::OnExecuteGsview()
{
	// TODO : ɃR}h nh R[hǉ܂B
	OnExecutePlatex();
	OnExecuteDvips();
	if (!m_TeXFileData.texFile.IsEmpty()) {
		CCommandType cmd = theApp.m_ExternCmd.Get(_T("GSView"));
		::ShellExecute(NULL, NULL, cmd.GetExeName(), cmd.GetOption(m_TeXFileData.texFileNoExt), m_TeXFileData.texFilePath, SW_SHOWNORMAL);
	}
}
