// UltraEditView.cpp : t@C
//

// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#include "stdafx.h"
#include "TeXnician.h"
#include "UltraEditView.h"
#include ".\ultraeditview.h"
#include "Values.h"
#include "ExternProgSettingDlg.h"
#include <new>

using namespace std;

// CUltraEditView

IMPLEMENT_DYNCREATE(CUltraEditView, CRichEditView)

CUltraEditView::CUltraEditView()
	: m_pLineWindow(NULL), m_pDullSense(NULL), m_LastLineCount(0), m_LineWindowWidth(0), m_SelStart(-1),
	  m_SelEnd(-1), m_CaretPos(-1), m_Previewing(FALSE)
{
	m_LastFindData.string.Empty();
	m_LastFindData.bcase = FALSE;
	m_LastFindData.bnext = FALSE;
	m_LastFindData.bword = FALSE;
}

CUltraEditView::~CUltraEditView()
{
	if (m_pLineWindow) {
		// EBhĚn
		delete m_pLineWindow;
	}
	if (m_pDullSense) {
		delete m_pDullSense;
	}
	m_pLineWindow = NULL;
	m_pDullSense = NULL;

	theApp.WriteProfileString(_T("DisplayFont"), _T("Name"), m_DisplayFont.fontName);
	theApp.WriteProfileInt(_T("DisplayFont"), _T("Size"), static_cast<int>(m_DisplayFont.fontSize));
}

BEGIN_MESSAGE_MAP(CUltraEditView, CRichEditView)
	ON_WM_CREATE()
	ON_CONTROL_REFLECT(EN_VSCROLL, OnEnVscroll)
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_CONTROL_REFLECT(EN_CHANGE, OnEnChange)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_ROWCOL, OnUpdateRowcol)
	ON_WM_RBUTTONDOWN()
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND_NEXT, OnUpdateEditFindNext)
	ON_COMMAND(ID_EDIT_FIND_NEXT, OnEditFindNext)
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
	ON_COMMAND(ID_EXECUTE_SETTING, OnExecuteSetting)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MBUTTONDBLCLK()
	ON_WM_MBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_DROPFILES()
	ON_UPDATE_COMMAND_UI(ID_VIEW_LINE_NUMBER, OnUpdateViewLineNumber)
	ON_COMMAND(ID_VIEW_LINE_NUMBER, OnViewLineNumber)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_VIEW_CHANGE_FONT, OnViewChangeFont)
END_MESSAGE_MAP()


// CUltraEditView ff

#ifdef _DEBUG
void CUltraEditView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CUltraEditView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}
#endif //_DEBUG


// CUltraEditView bZ[W nh

BOOL CUltraEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	cs.style |= WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_NOHIDESEL | ES_AUTOHSCROLL | ES_AUTOVSCROLL;

	return CRichEditView::PreCreateWindow(cs);
}

void CUltraEditView::OnInitialUpdate()
{
	// [hbv@\𖳌ɂ
	m_nWordWrap = 0;
	WrapChanged();

	CRichEditView::OnInitialUpdate();

	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	if (m_pLineWindow) {	// sԍ\pEBhEĕ`
		m_pLineWindow->RedrawWindow();
	}
}

int CUltraEditView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CRichEditView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO :  ɓȍ쐬R[hǉĂB
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	// ptHgArialɂȂ̂h~
	HWND hwnd = richEditCtrl.GetSafeHwnd();
	DWORD flag = (DWORD)::SendMessage(hwnd, EM_GETLANGOPTIONS, 0, 0);
	flag &= ~(IMF_DUALFONT | IMF_AUTOFONT);
	::SendMessage(hwnd, EM_SETLANGOPTIONS, 0, flag);
	// tHg̕ύX
	SetDisplayFont(FALSE);

	// sԍ\pEBhE쐬
	ShowLineWindow((BOOL)theApp.GetProfileInt(_T("ShowLineNumber"), _T("ShowLineNumber"), 1));

	// R[h⊮@\Lɂ
	if (!m_pDullSense) {
		try {
			m_pDullSense = new CDullSense;
			m_pDullSense->Create(WS_CHILD | WS_DISABLED | WS_VSCROLL | LBS_STANDARD, CRect(0, 0, 0, 0), this, IDC_DULLSENSE);
			m_pDullSense->SetParentView(this);
		} catch (bad_alloc xa) {
			m_pDullSense = NULL;
			AfxMessageBox(IDS_STRING_CANNOT_ENABLE_DULLSENSE, MB_OK | MB_ICONEXCLAMATION);
		}
	}

	return 0;
}

void CUltraEditView::OnEnVscroll()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_pLineWindow) {
		m_pLineWindow->RedrawWindow();
	}
}

void CUltraEditView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	CRichEditView::OnVScroll(nSBCode, nPos, pScrollBar);
	if (m_pLineWindow) {
		m_pLineWindow->RedrawWindow();
	}
}

void CUltraEditView::OnSize(UINT nType, int cx, int cy)
{
	CRichEditView::OnSize(nType, cx, cy);

	// TODO : ɃbZ[W nh R[hǉ܂B
	if (m_pLineWindow) {
		CRect rect;
		GetClientRect(&rect);
		rect.right = rect.left + m_LineWindowWidth;
		m_pLineWindow->MoveWindow(&rect);
	}
}

void CUltraEditView::OnEnChange()
{
	// TODO :  ꂪ RICHEDIT Rg[̏ꍇA܂ACRichEditView::OnInitDialog() ֐I[o[ChāA
	// OR Ԃ ENM_CORRECTTEXT tO}XNɓāA
	// CRichEditCtrl().SetEventMask() ĂяoȂA
	// Rg[́A̒ʒm𑗐M܂B

	// TODO :  ɃRg[ʒmnh R[hǉĂB
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	int lineCount = richEditCtrl.GetLineCount();
	if (lineCount != m_LastLineCount) {
		if (m_pLineWindow) {
			m_pLineWindow->RedrawWindow();
		}
		m_LastLineCount = lineCount;
	}
}

void CUltraEditView::OnUpdateRowcol(CCmdUI *pCmdUI)
{
	// Xe[^Xo[Ɍ݂̃J[\ʒu\
	// oBPp\RbNxXgE[wVisual C++ pp179-181

	if (!IsWindowEnabled()) {
		return;
	}

	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	long selStartNew, selEndNew, caretPosNew;
	richEditCtrl.GetSel(selStartNew, selEndNew);

	if (selEndNew == m_SelEnd) {
		if (selStartNew == m_SelStart) {
			caretPosNew = m_CaretPos;
		} else {
			caretPosNew = selStartNew;
		}
	} else if (selEndNew == m_SelStart) {
		caretPosNew = selStartNew;
	} else {
		caretPosNew = selEndNew;
	}

	m_CaretPos = caretPosNew;
	m_SelStart = selStartNew;
	m_SelEnd = selEndNew;
	int y = richEditCtrl.LineFromChar(caretPosNew);
	int x = caretPosNew - richEditCtrl.LineIndex(y);

	CString str, format;
	format.LoadString(IDS_STRING_ROWCOL);
	str.Format(format, (UINT)y + 1, (UINT)x + 1);
	pCmdUI->SetText(str);

	// łɓeɕύX`FbNĂ
	CRichEditDoc *pDoc = GetDocument();
	pDoc->SetModifiedFlag(richEditCtrl.GetModify());
}

void CUltraEditView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	if (!m_Previewing) {
		// vr[łȂ΁Ãr[ɃANeBuɂȂ悤ɂ
		GetParentFrame()->SetActiveView(this, FALSE);
	}

	CRichEditView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CUltraEditView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	// ⊮ꗗ\Ăꍇ́ANbN͖
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}
	// IDR_MENU_POPUPpopup0̓e\
	CMenu menu;
	menu.LoadMenu(IDR_MENU_POPUP);
	CMenu *pMenu = menu.GetSubMenu(0);

	// eڂ̗L/ݒ肷
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	long selStartPos, selEndPos;
	richEditCtrl.GetSel(selStartPos, selEndPos);
	if (selStartPos == selEndPos) {
		pMenu->EnableMenuItem(ID_EDIT_CUT, MF_BYCOMMAND | MF_GRAYED);
		pMenu->EnableMenuItem(ID_EDIT_COPY, MF_BYCOMMAND | MF_GRAYED);
	} else {
		pMenu->EnableMenuItem(ID_EDIT_CUT, MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_COPY, MF_BYCOMMAND | MF_ENABLED);
	}
	if (richEditCtrl.CanPaste(CF_TEXT)) {
		pMenu->EnableMenuItem(ID_EDIT_PASTE, MF_BYCOMMAND | MF_ENABLED);
	} else {
		pMenu->EnableMenuItem(ID_EDIT_PASTE, MF_BYCOMMAND | MF_GRAYED);
	}

	ClientToScreen(&point);
	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
	menu.DestroyMenu();

//	CRichEditView::OnRButtonDown(nFlags, point);
}

void CUltraEditView::OnUpdateEditPaste(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	// eLXgȊǑ`͒荞߂Ȃ悤ɂ

	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	UINT format;
#ifdef _UNICODE
	format = CF_UNICODETEXT;
#else
	format = CF_TEXT;
#endif
	if (richEditCtrl.CanPaste(format)) {
		pCmdUI->Enable(TRUE);
	} else {
		pCmdUI->Enable(FALSE);
	}

}

void CUltraEditView::OnTextNotFound(LPCTSTR lpszFind)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	// eLXgȂ|\B
	CString msg;
	if (m_LastFindData.bnext) {
		msg.LoadString(IDS_STRING_SEARCH_BOTTOM);
	} else {
		msg.LoadString(IDS_STRING_SEARCH_TOP);
	}
	AfxMessageBox(msg, MB_OK | MB_ICONINFORMATION);

//	CRichEditView::OnTextNotFound(lpszFind);
}

void CUltraEditView::OnFindNext(LPCTSTR lpszFind, BOOL bNext, BOOL bCase, BOOL bWord)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	// j[́uvɔāAۑĂ
	m_LastFindData.string = lpszFind;
	m_LastFindData.bnext = bNext;
	m_LastFindData.bcase = bCase;
	m_LastFindData.bword = bWord;

	CRichEditView::OnFindNext(lpszFind, bNext, bCase, bWord);
}

void CUltraEditView::OnUpdateEditFindNext(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	if (m_LastFindData.string.IsEmpty()) {
		pCmdUI->Enable(FALSE);
	} else {
		pCmdUI->Enable(TRUE);
	}
}

void CUltraEditView::OnEditFindNext()
{
	// TODO : ɃR}h nh R[hǉ܂B
	if (!FindTextSimple(m_LastFindData.string, m_LastFindData.bcase, m_LastFindData.bword, m_LastFindData.bnext)) {
		OnTextNotFound(m_LastFindData.string);
	}
}

void CUltraEditView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense) {
#ifndef _UNICODE
		// UNICODEŃRpCĂȂ΁A\ǂ𐳂肷邽߂ɂ̓L[͂Kv
		if (nChar == VK_OEM_5 || nChar == VK_OEM_102) {
			m_pDullSense->SetBackslashKeyDown(TRUE);
		} else {
			m_pDullSense->SetBackslashKeyDown(FALSE);
		}
#endif
		if (m_pDullSense->IsWindowVisible()) {
			switch (nChar) {
				case VK_ESCAPE:
					m_pDullSense->AppearWindow(FALSE);
					return;
					break;
				case VK_UP:
					m_pDullSense->ItemUpDown(FALSE);
					return;
					break;
				case VK_DOWN:
					m_pDullSense->ItemUpDown(TRUE);
					return;
					break;
				case VK_HOME:
					m_pDullSense->ItemTopBottom(FALSE);
					return;
					break;
				case VK_END:
					m_pDullSense->ItemTopBottom(TRUE);
					return;
					break;
				case VK_PRIOR:
					m_pDullSense->ItemPageBackNext(FALSE);
					return;
					break;
				case VK_NEXT:
					m_pDullSense->ItemPageBackNext(TRUE);
					return;
					break;
				case VK_LEFT:
				case VK_RIGHT:
				case VK_DELETE:
					// ꗗ\͍EL[ADeleteL[͖ɂ
					return;
					break;
			}
		}
	}

	CRichEditView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CUltraEditView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense) {
		BOOL control = TRUE;
		BOOL complete = FALSE;
		if (nChar != _T('\r') && nChar != _T('\n') && nChar != _T('\t')) {	// U͂Ă
			control = FALSE;
			CRichEditView::OnChar(nChar, nRepCnt, nFlags);
		}
		CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
check:
		long startPos, endPos;
		richEditCtrl.GetSel(startPos, endPos);
		CString str;
		if (m_pDullSense->SetNextChar(nChar, &str)) {
			richEditCtrl.SetSel(m_pDullSense->GetCompleteStartPosition(), endPos);
			richEditCtrl.ReplaceSel(str);
			complete = TRUE;
			goto check;
		}
		if (control && !complete) {
			CRichEditView::OnChar(nChar, nRepCnt, nFlags);
		}
		return;
	}

	CRichEditView::OnChar(nChar, nRepCnt, nFlags);
}

void CUltraEditView::OnExecuteSetting()
{
	// TODO : ɃR}h nh R[hǉ܂B
	CExternProgSettingDlg dlg;
	dlg.DoModal();		// ݒ̔f́A_CAOs
}

void CUltraEditView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}

	CRichEditView::OnLButtonDown(nFlags, point);
}

void CUltraEditView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}
	CRichEditView::OnLButtonDblClk(nFlags, point);
}

void CUltraEditView::OnMButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}
	CRichEditView::OnMButtonDblClk(nFlags, point);
}

void CUltraEditView::OnMButtonDown(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}
	CRichEditView::OnMButtonDown(nFlags, point);
}

void CUltraEditView::OnRButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if (m_pDullSense && m_pDullSense->IsWindowVisible()) {
		return;
	}
	CRichEditView::OnRButtonDblClk(nFlags, point);
}

void CUltraEditView::OnDropFiles(HDROP hDropInfo)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	theApp.m_pMainWnd->SendMessage(WM_DROPFILES, (WPARAM)hDropInfo);
//	CRichEditView::OnDropFiles(hDropInfo);
}

HRESULT CUltraEditView::QueryAcceptData(LPDATAOBJECT lpdataobj, CLIPFORMAT* lpcfFormat, DWORD dwReco, BOOL bReally, HGLOBAL hMetaFile)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	COleDataObject obj;
	obj.Attach(lpdataobj, FALSE);
	CLIPFORMAT format;
#ifdef _UNICODE
	format = CF_UNICODETEXT;
#else
	format = CF_TEXT;
#endif
	if (obj.IsDataAvailable(format)) {
		return CRichEditView::QueryAcceptData(lpdataobj, lpcfFormat, dwReco, bReally, hMetaFile);
	} else {
		return E_NOINTERFACE;
	}
}

VOID CUltraEditView::ShowLineWindow(BOOL flag)
{
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	if (flag) {
		// sԍ\
		if (!m_pLineWindow) {
			try {
				// vZ

				// tHg
				CHARFORMAT2 cf;
				richEditCtrl.GetDefaultCharFormat(cf);
				LOGFONT lf;
				memset(&lf, 0, sizeof(lf));
				_tcscpy(lf.lfFaceName, cf.szFaceName);
				CClientDC dc(this);
				lf.lfHeight = static_cast<LONG>(static_cast<double>(cf.yHeight) * static_cast<double>(dc.GetDeviceCaps(LOGPIXELSY)) / 1440.0);
				CFont newFont;
				newFont.CreateFontIndirect(&lf);
				CFont *oldFont = dc.SelectObject(&newFont);
				TEXTMETRIC metrics;
				dc.GetTextMetrics(&metrics);
				m_LineWindowWidth = metrics.tmAveCharWidth * 5 + WINDOW_HSPACE;
				dc.SelectObject(oldFont);
				newFont.DeleteObject();

				CRect rect;
				GetClientRect(&rect);
				rect.DeflateRect(m_LineWindowWidth, 0, 0, 0);
				richEditCtrl.SetRect(&rect);
				GetClientRect(&rect);
				rect.right = rect.left + m_LineWindowWidth;
				m_pLineWindow = new CLineWindow;
				m_pLineWindow->Create(NULL, _T(""), WS_CHILD | WS_VISIBLE, rect, this, 0);
				CHARFORMAT2 format;
				richEditCtrl.GetDefaultCharFormat(format);
				m_pLineWindow->RedrawWindow();
			} catch (bad_alloc xa) {
				m_pLineWindow = NULL;
				AfxMessageBox(IDS_STRING_CANNOT_CREATE_LINEWINDOW, MB_OK | MB_ICONEXCLAMATION);
			}
			theApp.WriteProfileInt(_T("ShowLineNumber"), _T("ShowLineNumber"), 1);
		}
	} else {	
		// sԍ\
		if (m_pLineWindow) {
			m_pLineWindow->DestroyWindow();
			delete m_pLineWindow;
			m_pLineWindow = NULL;
			CRect rect;
			GetClientRect(&rect);
			richEditCtrl.SetRect(&rect);
			theApp.WriteProfileInt(_T("ShowLineNumber"), _T("ShowLineNumber"), 0);
		}
	}
}

void CUltraEditView::SetDisplayFont(BOOL flag)
{
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();

	CHARFORMAT2 cf;
	if (!flag) {
		richEditCtrl.GetDefaultCharFormat(cf);
		m_DisplayFont.fontName = theApp.GetProfileString(_T("DisplayFont"), _T("Name"), cf.szFaceName);
		m_DisplayFont.fontSize = static_cast<LONG>(theApp.GetProfileInt(_T("DisplayFont"), _T("Size"), static_cast<int>(cf.yHeight)));
	}

	memset(&cf, 0, sizeof(cf));
	cf.cbSize = sizeof(cf);
	cf.dwMask = CFM_FACE | CFM_SIZE;
	_tcscpy(cf.szFaceName, m_DisplayFont.fontName);
	cf.yHeight = m_DisplayFont.fontSize;
	if (flag) {
		long caretStartPos, caretEndPos;
		richEditCtrl.GetSel(caretStartPos, caretEndPos);
		richEditCtrl.SetSel(0, -1);
		richEditCtrl.SetSelectionCharFormat(cf);
		richEditCtrl.SetSel(caretStartPos, caretEndPos);
	}
	richEditCtrl.SetDefaultCharFormat(cf);
}

void CUltraEditView::OnUpdateViewLineNumber(CCmdUI *pCmdUI)
{
	// TODO : ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck((m_pLineWindow) ? TRUE : FALSE);
}

void CUltraEditView::OnViewLineNumber()
{
	// TODO : ɃR}h nh R[hǉ܂B
	// sԍ\pEBhE\邩ǂ
	ShowLineWindow((m_pLineWindow) ? FALSE : TRUE);
}

void CUltraEditView::OnEditPaste()
{
	// TODO : ɃR}h nh R[hǉ܂B
	CLIPFORMAT format;
#ifdef _UNICODE
	format = CF_UNICODETEXT;
#else
	format = CF_TEXT;
#endif
	CRichEditCtrl &richEditCtrl = GetRichEditCtrl();
	if (::IsClipboardFormatAvailable(format)) {
		if (::OpenClipboard(NULL)) {
			HANDLE hMem(::GetClipboardData(format));
			LPCTSTR pMem(static_cast<LPCTSTR>(::GlobalLock(hMem)));
			richEditCtrl.ReplaceSel(pMem, TRUE);
			::GlobalUnlock(hMem);
			::CloseClipboard();
		}
	}
}

void CUltraEditView::OnViewChangeFont()
{
	// TODO : ɃR}h nh R[hǉ܂B
	LOGFONT lf;
	memset(&lf, 0, sizeof(lf));
	_tcscpy(lf.lfFaceName, m_DisplayFont.fontName);
	CClientDC dc(this);
	lf.lfHeight = - static_cast<LONG>(static_cast<double>(m_DisplayFont.fontSize) * static_cast<double>(dc.GetDeviceCaps(LOGPIXELSY)) / 1440.0);
	CFontDialog fontDlg(&lf, CF_SCREENFONTS);

	if (fontDlg.DoModal() == IDOK) {
		m_DisplayFont.fontName = lf.lfFaceName;
		m_DisplayFont.fontSize = - static_cast<LONG>(static_cast<double>(lf.lfHeight) / static_cast<double>(dc.GetDeviceCaps(LOGPIXELSY)) * 1440.0);
		SetDisplayFont();
		if (m_pLineWindow) {
			ShowLineWindow(FALSE);
			ShowLineWindow(TRUE);
		}
	}
}
