// Copyright (C) 2005-2006 Satoshi Eguchi. All rights reserved.

#pragma once

#include "LineWindow.h"
#include "DullSense.h"

// CUltraEditView r[

class CUltraEditView : public CRichEditView
{
	DECLARE_DYNCREATE(CUltraEditView)

protected:
	CUltraEditView();           // IŎgp protected RXgN^
	virtual ~CUltraEditView();

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	afx_msg void OnUpdateRowcol(CCmdUI *pCmdUI);
	DECLARE_MESSAGE_MAP()

private:
	CLineWindow *m_pLineWindow;			// sԍ\pEBhE
	CDullSense *m_pDullSense;			// ͕⊮@\
	int m_LastLineCount;				// ŌɊmFAeLXg̍s
	int m_LineWindowWidth;				// sԍ\pEBhE̕
	long m_SelStart;					// I̊Jnʒu
	long m_SelEnd;						// ȈIʒu
	long m_CaretPos;					// J[\ʒu
	BOOL m_Previewing;					// vr[\
	typedef struct {		// Ɋւf[^ێ
		CString string;			// ̕
		BOOL bnext;				//  = TRUE,  = FALSE
		BOOL bcase;				// 啶Ə̋(ʂ = TRUE, ʂȂ = FALSE)
		BOOL bword;				// Pꌟ(PP = TRUE, ꕔł = FALSE)
	}FindDataStruct;
	FindDataStruct m_LastFindData;
	BOOL m_TypingFunctionName;			// ֐͒
	typedef struct {		// ʕ\ptHgێ
		CString fontName;				// tHg
		LONG fontSize;					// tHgTCY
	}DisplayFontStruct;
	DisplayFontStruct m_DisplayFont;	// \ptHg

private:
	VOID ShowLineWindow(BOOL flag = TRUE);	// sԍ\pEBhE\ (flag = TRUE : \, flag = FALSE : \);
	void SetDisplayFont(BOOL flag= TRUE);	// \tHgݒ (flag = FALSE : )
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	virtual void OnInitialUpdate();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnEnVscroll();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnEnChange();
protected:
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
public:
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnUpdateEditPaste(CCmdUI *pCmdUI);
protected:
	virtual void OnTextNotFound(LPCTSTR lpszFind);
	virtual void OnFindNext(LPCTSTR lpszFind, BOOL bNext, BOOL bCase, BOOL bWord);
public:
	afx_msg void OnUpdateEditFindNext(CCmdUI *pCmdUI);
	afx_msg void OnEditFindNext();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnExecuteSetting();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnDropFiles(HDROP hDropInfo);
protected:
	virtual HRESULT QueryAcceptData(LPDATAOBJECT lpdataobj, CLIPFORMAT* lpcfFormat, DWORD dwReco, BOOL bReally, HGLOBAL hMetaFile);
public:
	afx_msg void OnUpdateViewLineNumber(CCmdUI *pCmdUI);
	afx_msg void OnViewLineNumber();
	afx_msg void OnEditPaste();
	afx_msg void OnViewChangeFont();
};


